<?php

/*
Plugin Name: Metz Components
Plugin URI: http://www.burnhambox.com/metz
Description: Components for Metz theme.
Version: 1.0.2
Author: Burnhambox
Author URI: http://www.burnhambox.com
License: GNU
*/

/* Share Icons */
if ( !function_exists( 'metz_shortcode_share' ) ) {
  function metz_shortcode_share( $atts ) {

    $output = '';

    $a = shortcode_atts( array(
        'ID' => '0',
    ), $atts );

    if ( $a['ID'] == '' ) { $a['ID'] = 0; }

    //

    /* Translation */
    $brnhmbx_tra_Share = esc_html__( 'SHARE', 'metz' );

    if ( get_theme_mod( 'metz_ignorePot', 1 ) ) {

    $brnhmbx_tra_Share = get_theme_mod( 'brnhmbx_tra_Share', 'SHARE' );

    }
    /* */

    $brnhmbx_sh_SocialBar_Facebook = get_theme_mod( 'brnhmbx_sh_SocialBar_Facebook', 1 );
    $brnhmbx_sh_SocialBar_Twitter = get_theme_mod( 'brnhmbx_sh_SocialBar_Twitter', 1 );
    $brnhmbx_sh_SocialBar_Google = get_theme_mod( 'brnhmbx_sh_SocialBar_Google', 1 );
    $brnhmbx_sh_SocialBar_Pinterest = get_theme_mod( 'brnhmbx_sh_SocialBar_Pinterest', 1 );
    $brnhmbx_sh_SocialBar = get_theme_mod( 'brnhmbx_sh_SocialBar', 1 );
    if ( !$brnhmbx_sh_SocialBar_Facebook && !$brnhmbx_sh_SocialBar_Twitter && !$brnhmbx_sh_SocialBar_Google && !$brnhmbx_sh_SocialBar_Pinterest ) {
    	$brnhmbx_sh_SocialBar = 0;
    }

    if ( $brnhmbx_sh_SocialBar && ( is_single() || is_page() ) ) {

  		$output .= '<div class="social-bar-outer clearfix">';
      $output .= '<div class="fs11 montserrat social-bg">' . esc_attr( $brnhmbx_tra_Share ) . '</div>';
      $output .= '<div class="social-bar fs20">';
  		if ( $brnhmbx_sh_SocialBar_Facebook ) { $output .= '<a href="https://www.facebook.com/sharer/sharer.php?u=' . esc_url( get_permalink( $a['ID'] ) ) . '" target="_blank"><i class="fa fa-facebook"></i></a>'; }
      if ( $brnhmbx_sh_SocialBar_Twitter ) { $output .= '<a href="https://twitter.com/share?url=' . esc_url( get_permalink( $a['ID'] ) ) . '" target="_blank"><i class="fa fa-twitter"></i></a>'; }
      if ( $brnhmbx_sh_SocialBar_Google ) { $output .= '<a href="https://plus.google.com/share?url=' . esc_url( get_permalink( $a['ID'] ) ) . '" target="_blank"><i class="fa fa-google-plus"></i></a>'; }
      $output .= '</div>';
      $output .= '</div>';

  	}

    return $output;

  }
}
add_shortcode( 'metz_share', 'metz_shortcode_share' );
/* */

/* Hit Counter */
if ( !function_exists( 'metz_getPostViews' ) ) {
	function metz_getPostViews( $postID ) {

	    $count_key = 'post_views_count';
	    $count = get_post_meta( $postID, $count_key, true );

	    if ( $count == '' ) {

	        delete_post_meta( $postID, $count_key );
	        add_post_meta( $postID, $count_key, '0' );
	        return '0';

	    }

	    return $count;

	}
}

if ( !function_exists( 'metz_setPostViews' ) ) {
	function metz_setPostViews( $postID ) {

	    $count_key = 'post_views_count';
	    $count = get_post_meta( $postID, $count_key, true );

	    if ( $count == '' ) {

	        $count = 0;
	        delete_post_meta( $postID, $count_key );
	        add_post_meta( $postID, $count_key, '0' );

	    } else {

	        $count ++;
	        update_post_meta( $postID, $count_key, $count );

	    }

	}
}
/* */

/* metz_customAdWidget Class */
class metz_customAdWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'metz_customAdWidget',
			'Metz Widget: Ads',
			array( 'description' => "A widget for your Ads. Just place your code and you're done." )

		);
	}

	public function form( $instance ) {

		$instance = wp_parse_args( ( array ) $instance, array( 'text' => '' ) );
		$text = esc_textarea( $instance['text'] );

		?>

		<p><textarea class="widefat" rows="16" cols="20" id="<?php echo esc_attr( $this->get_field_id('text') ); ?>" name="<?php echo esc_attr( $this->get_field_name('text') ); ?>"><?php echo wp_kses_post( $text ); ?></textarea></p>

		<?php

	}

	public function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		if ( current_user_can( 'unfiltered_html' ) ) {

			$instance['text'] =  $new_instance['text'];

		} else {

			$instance['text'] = stripslashes( wp_filter_post_kses( addslashes( $new_instance['text'] ) ) ); // wp_filter_post_kses() expects slashed

		}

		$instance['filter'] = ! empty( $new_instance['filter'] );

		return $instance;

	}

	public function widget( $args, $instance ) {

		extract( $args );

		$text = apply_filters( 'widget_text', empty( $instance['text'] ) ? '' : $instance['text'], $instance );

		if ( $id == 'brnhmbx_footer_widgets' ) {

			$fw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColFooter', 1 ) ) { $fw_col_number = '-col2'; }
			echo '<div class="widget-item-footer-outer' . esc_attr( $fw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_home_widgets' ) {

			$hw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColHome', 0 ) ) { $hw_col_number = '-col2'; }
			if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) { $hw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-home-outer' . esc_attr( $hw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_upper_widgets' ) {

			$uw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColUpper', 0 ) ) { $uw_col_number = '-col2'; }
			if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) { $uw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-upper-outer' . esc_attr( $uw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_header_widgets' ) {

			$hew_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_headerWidgetsCol', 0 ) ) { $hew_col_number = '-col2'; }
			echo '<div class="widget-item-header-outer' . esc_attr( $hew_col_number ) . '">';

		} else {

			echo '<div id="' . esc_attr( $this->id ) . '">';

		}

		?>

        <div class="textwidget adwidget mb20"><?php echo !empty( $instance['filter'] ) ? wpautop( $text ) : $text; ?></div>

		<?php

		echo '</div>';

	}

}

/* metz_customCatPostsWidget Class */
class metz_customCatPostsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'metz_customCatPostsWidget',
			'Metz Widget: Category/Tag Posts',
			array( 'description' => "Display the posts belong to a specific category or tag." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'CATEGORY/TAG POSTS', 'opt_hdr' => 'OPTIONAL HEADLINE', 'count' => 5, 'styleB_count' => 1, 'styleC_count' => 3, 'date' => 'on', 'comments' => 'on', 'hits' => 'on', 'text_color' => '#756c4c', 'background_color' => '#ebe4ca', 'range' => '100', 'category' => 'uncategorized', 'tag' => '', 'show_cats' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <script type='text/javascript'>

            jQuery( document ).ready( function($) {

                $('.ctw-bg-color-picker').wpColorPicker( {

		            defaultColor: '#ebe4ca',
					change: _.throttle( function() { $('.ctw-bg-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				$('.ctw-t-color-picker').wpColorPicker( {

		            defaultColor: '#756c4c',
					change: _.throttle( function() { $('.ctw-t-color-picker').trigger( 'change' ) }, 3000 ),

				} );

            } );

        </script>

        <p>Write a Category Slug:<br />
        <p><input id="get-dropdown-val-cat" name="<?php echo esc_attr( $this->get_field_name( 'category' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['category'] ); ?>" /></p>
        <p><strong>OR</strong></p><p>Write a Tag Slug:<br />
        <p><input id="get-dropdown-val-tag" name="<?php echo esc_attr( $this->get_field_name( 'tag' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['tag'] ); ?>" /></p>
        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['show_cats'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'show_cats' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'show_cats' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'show_cats' ) ); ?>">Show Categories</label>
		</p>
		<p>Title: <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>
        <p>Optional Headline: <input name="<?php echo esc_attr( $this->get_field_name( 'opt_hdr' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['opt_hdr'] ); ?>" style="width: 100%;" /></p>
        <p>Number of posts to show: <input name="<?php echo esc_attr( $this->get_field_name( 'count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['count'] ); ?>" style="width: 50px;" /></p>
        <p><em>The default post style is "Style A".</em></p>
        <p>Post count for "Style B": <input name="<?php echo esc_attr( $this->get_field_name( 'styleB_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleB_count'] ); ?>" style="width: 50px;" /></p>
        <p>Post count for "Style C": <input name="<?php echo esc_attr( $this->get_field_name( 'styleC_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleC_count'] ); ?>" style="width: 50px;" /></p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['date'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'date' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>">Display post date?</label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['comments'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'comments' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'comments' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'comments' ) ); ?>">Display comments icon?</label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['hits'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'hits' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'hits' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'hits' ) ); ?>">Display visitor hits?</label>
		</p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>">Box Color:</label>
		<br />
		<input class="ctw-bg-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'background_color' ) ); ?>" value="<?php echo esc_attr( $instance['background_color'] ); ?>" />
        </p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>">Link Color:</label>
		<br />
		<input class="ctw-t-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'text_color' ) ); ?>" value="<?php echo esc_attr( $instance['text_color'] ); ?>" />
        </p>

        <p>Box Opacity:<br />
        <input name="<?php echo esc_attr( $this->get_field_name( 'range' ) ); ?>" type="range" min="0" max="100" step="10" value="<?php echo esc_attr( $instance['range'] ); ?>" />
        </p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['name'] = ( !empty( $new_instance['name'] ) ) ? strip_tags( $new_instance['name'] ) : 'CATEGORY/TAG POSTS';
		$instance['opt_hdr'] = $new_instance['opt_hdr'];
		$instance['count'] = ( !empty( $new_instance['count'] ) ) ? strip_tags( $new_instance['count'] ) : '5';
		$instance['styleB_count'] = $new_instance['styleB_count'];
		$instance['styleC_count'] = $new_instance['styleC_count'];
		$instance['date'] = $new_instance['date'];
		$instance['comments'] = $new_instance['comments'];
		$instance['hits'] = $new_instance['hits'];
		$instance['text_color'] = $new_instance['text_color'];
		$instance['background_color'] = $new_instance['background_color'];
		$instance['range'] = $new_instance['range'];
		$instance['category'] = $new_instance['category'];
		$instance['tag'] = $new_instance['tag'];
		$instance['show_cats'] = $new_instance['show_cats'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'name' => 'CATEGORY/TAG POSTS', 'opt_hdr' => 'OPTIONAL HEADLINE', 'count' => 5, 'styleB_count' => 1, 'styleC_count' => 3, 'date' => 'on', 'comments' => 'on', 'hits' => 'on', 'text_color' => '#756c4c', 'background_color' => '#ebe4ca', 'range' => '100', 'category' => 'uncategorized', 'tag' => '', 'show_cats' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$name = apply_filters( 'widget_title', $instance['name'] );
		$opt_hdr = $instance['opt_hdr'];
		$count = $instance['count'];
		$styleB_count = $instance['styleB_count'];
		$styleC_count = $instance['styleC_count'];
		$date = $instance['date'] ? 'true' : 'false';
		$comments = $instance['comments'] ? 'true' : 'false';
		$hits = $instance['hits'] ? 'true' : 'false';
		$text_color = $instance['text_color'];
		$background_color = $instance['background_color'];
		$range = $instance['range'];
		$category = $instance['category'];
		$tag = $instance['tag'];
		$show_cats = $instance['show_cats'] ? 'true' : 'false';

		/* Combine Widget Listing Settings */

		$w_listing_style = 'a';
		$w_listingOrder = 0;

		if ( $styleB_count + $styleC_count > $count ) {

			$styleB_count = 0;
			$styleC_count = 0;

		}

		/* */

		$cpw_rand = rand( 1, 9999999 ); ?>

        <style type="text/css" scoped>

			<?php echo esc_attr( 'a.cpw-' . $cpw_rand ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.cpw-' . $cpw_rand . ':visited' ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.cpw-' . $cpw_rand ); ?> div.related-post-item-header-a .rpih-inner-a,
			<?php echo esc_attr( 'a.cpw-' . $cpw_rand . ':visited' ); ?> div.related-post-item-header-a .rpih-inner-a,
			<?php echo esc_attr( 'a.cpw-' . $cpw_rand ); ?> div.related-post-item-header-b .rpih-inner-b,
			<?php echo esc_attr( 'a.cpw-' . $cpw_rand . ':visited' ); ?> div.related-post-item-header-b .rpih-inner-b,
			<?php echo esc_attr( 'a.cpw-' . $cpw_rand ); ?>,
			<?php echo esc_attr( 'a.cpw-' . $cpw_rand ); ?> div.widget-listing-c { background: rgba(<?php echo esc_attr( metz_hex2rgb( $background_color ) ) . ',' . esc_attr( $range ) / 100; ?>); color: <?php echo esc_attr( $text_color ); ?>; -webkit-transition: all 0.3s ease-out; transition: all 0.3s ease-out; }
			<?php echo esc_attr( 'a.cpw-' . $cpw_rand . ':hover' ); ?>,
			<?php echo esc_attr( 'a.cpw-' . $cpw_rand . ':hover' ); ?> div.widget-listing-c,
			<?php echo esc_attr( 'a.cpw-' . $cpw_rand . ':hover' ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.cpw-' . $cpw_rand . ':hover' ); ?> div.related-post-item-header-a .rpih-inner-a,
			<?php echo esc_attr( 'a.cpw-' . $cpw_rand . ':hover' ); ?> div.related-post-item-header-b .rpih-inner-b { background: rgba(<?php echo esc_attr( metz_hex2rgb( $text_color ) ) . ', 1'; ?>); color: <?php echo esc_attr( $background_color ); ?>; }

		</style>

        <?php

		if ( !empty( $name ) ) {

			echo wp_kses_post( $before_title ) . esc_attr( $name ) . wp_kses_post( $after_title ) . '<div class="montserrat widget-item-opt-hdr">' . esc_attr( $opt_hdr ) . '</div>';

			/* function */

			if ( $show_cats == 'true' ) {

				$loop_args = array(

					'showposts' => esc_attr( $count ),
					'category_name' => $category,
					'ignore_sticky_posts' => 1

				);

			} else {

				$loop_args = array(

					'showposts' => esc_attr( $count ),
					'tag' => $tag,
					'ignore_sticky_posts' => 1

				);

			}

			$rPosts = new WP_Query( $loop_args );

			while ( $rPosts->have_posts() ) : $rPosts->the_post();

			//Combine Widget Listing Settings Styles

			$w_listingOrder ++;

			if ( $styleB_count > 0 && ( $w_listingOrder > $count - ( $styleB_count + $styleC_count ) && $w_listingOrder <= $count - $styleC_count ) ) {

				$w_listing_style = 'b';

			}

			if ( $styleC_count > 0 && ( $w_listingOrder > $count - $styleC_count ) ) {

				$w_listing_style = 'c';

			}

			if ( $w_listing_style == 'a' || $w_listing_style == 'b' ) { ?>

                <div class="clearfix widget-listing-a-b box-a-wi">

                	<?php if ( $date == 'true' || ( $comments == 'true' && comments_open() ) || $hits == 'true' ) { ?>

                        <div class="montserrat clearfix widget-date-bar">

                            <?php if ( $date == 'true' ) { ?>

                                <div class="left"><?php echo '<a href="' . esc_url( get_the_permalink() ) . '" class="date-a">' . get_the_date() . '</a>' ?></div>

                            <?php } ?>

                                <div class="right">

                                    <?php if ( $comments == 'true' && comments_open() ) { ?>

                                        <a href="<?php esc_url( the_permalink() ); ?>#comments"><i class="fa fa-comment-o i-spcr-r clock"></i><?php comments_number( '0 ', '1 ', '% ' ); ?></a><?php } ?>

                                        <?php if ( $hits == 'true' ) { ?><i class="fa fa-bolt i-spcr-r <?php if ( $comments == 'true' && comments_open() ) { echo 'i-spcr-l2'; } ?> clock"></i><?php echo metz_getPostViews( get_the_ID() ); } ?>

                                </div>

                        </div>

                    <?php } ?>

                    <a class="<?php echo esc_attr( 'cpw-' . $cpw_rand ); ?>" href="<?php esc_url( the_permalink() ); ?>">
                        <?php if ( has_post_thumbnail() ) { ?><div><?php the_post_thumbnail( 'related-thumbnail' ); ?></div><?php } else if ( $w_listing_style == 'a' ) { ?><div class="rp-a-without-image"></div><?php } ?>
                        <div class="related-post-item-header-<?php echo esc_attr( $w_listing_style ); ?> playfair">
							<div class="rpih-inner-<?php echo esc_attr( $w_listing_style ); ?>">
                            	<div class="rpih-text-<?php echo esc_attr( $w_listing_style ); ?>"><?php the_title(); ?></div>
                            </div>
                        </div>
                    </a>
                </div>

			<?php } else if ( $w_listing_style == 'c' ) { ?>

                <a class="<?php echo esc_attr( 'cpw-' . $cpw_rand ); ?>" href="<?php esc_url( the_permalink() ); ?>">
	                <div class="widget-listing-c clearfix">
						<?php if ( has_post_thumbnail() ) { ?><div><?php echo the_post_thumbnail( 'page-navigation-thumbnail' ); ?></div><?php } ?>
						<div class="widget-listing-c-info <?php if ( has_post_thumbnail() ) { echo 'widget-listing-c-info-with-t'; } ?>">
							<div class="table-cell-middle"><span class="playfair widget-listing-c-title"><?php the_title(); ?></span></div>
						</div>
	                </div>
                </a>

			<?php } ?>

			<?php endwhile;

			wp_reset_postdata();

			/* */

		}

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

/* metz_customCatsWidget Class */
class metz_customCatsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'metz_customCatsWidget',
			'Metz Widget: Tags/Categories',
			array( 'description' => "A well styled list of your tags or categories." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'TAGS', 'opt_hdr' => 'OPTIONAL HEADLINE', 'tag_count' => '0', 'cat_count' => '0', 'show_tags' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <p><em>Uncheck "Show Tags" below to show categories.</em></p>
        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['show_tags'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'show_tags' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'show_tags' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'show_tags' ) ); ?>">Show Tags</label>
		</p>
		<p>Title: <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>
        <p>Optional Headline: <input name="<?php echo esc_attr( $this->get_field_name( 'opt_hdr' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['opt_hdr'] ); ?>" style="width: 100%;" /></p>
        <p>Number of Tags to show:<br />
        <input name="<?php echo esc_attr( $this->get_field_name( 'tag_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['tag_count'] ); ?>" style="width: 50px;" /></p>
        <p><em>Write "0" to display all tags/categories.</em></p>
        <p>Number of Categories to show: <input name="<?php echo esc_attr( $this->get_field_name( 'cat_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['cat_count'] ); ?>" style="width: 50px;" /></p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['name'] = ( !empty( $new_instance['name'] ) ) ? strip_tags( $new_instance['name'] ) : 'TAGS';
		$instance['opt_hdr'] = $new_instance['opt_hdr'];
		$instance['tag_count'] = $new_instance['tag_count'];
		$instance['cat_count'] = $new_instance['cat_count'];
		$instance['show_tags'] = $new_instance['show_tags'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'name' => 'TAGS', 'opt_hdr' => 'OPTIONAL HEADLINE', 'tag_count' => '0', 'cat_count' => '0', 'show_tags' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$name = apply_filters( 'widget_title', $instance['name'] );
		$opt_hdr = $instance['opt_hdr'];
		$tag_count = $instance['tag_count'];
		$cat_count = $instance['cat_count'];
		$show_tags = $instance['show_tags'] ? 'true' : 'false';

		$taxonomy = '';
		$count = 0;

		if ( $show_tags == 'true' ) {

			$taxonomy = 'post_tag';
			$count = esc_attr( $tag_count );

		} else {

			$taxonomy = 'category';
			$count = esc_attr( $cat_count );

		}

		if ( !empty( $name ) ) {

			echo wp_kses_post( $before_title ) . esc_attr( $name ) . wp_kses_post( $after_title ) . '<div class="montserrat widget-item-opt-hdr">' . esc_attr( $opt_hdr ) . '</div>';

			/* function */

			$tag_args = array(

				'smallest'                  => 11,
				'largest'                   => 11,
				'unit'                      => 'px',
				'number'                    => $count,
				'format'                    => 'list',
				'taxonomy'                  => $taxonomy,

			);

			echo '<div class="montserrat clearfix mt-7">';
			wp_tag_cloud( $tag_args );
			echo '</div>';

			/* */

		}

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

/* metz_customEmptySpaceWidget Class */
class metz_customEmptySpaceWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'metz_customEmptySpaceWidget',
			'Metz Widget: Empty Space',
			array( 'description' => "Just place an empty space between your widgets if you wish. It's very handy!" )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'count' => 20 );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <p>Height: <input name="<?php echo esc_attr( $this->get_field_name( 'count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['count'] ); ?>" style="width: 50px;" /></p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['count'] = ( !empty( $new_instance['count'] ) ) ? strip_tags( $new_instance['count'] ) : '20';

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		if ( $id == 'brnhmbx_footer_widgets' ) {

			$fw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColFooter', 1 ) ) { $fw_col_number = '-col2'; }
			echo '<div class="widget-item-footer-outer' . esc_attr( $fw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_home_widgets' ) {

			$hw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColHome', 0 ) ) { $hw_col_number = '-col2'; }
			if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) { $hw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-home-outer' . esc_attr( $hw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_upper_widgets' ) {

			$uw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColUpper', 0 ) ) { $uw_col_number = '-col2'; }
			if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) { $uw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-upper-outer' . esc_attr( $uw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_header_widgets' ) {

			$hew_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_headerWidgetsCol', 0 ) ) { $hew_col_number = '-col2'; }
			echo '<div class="widget-item-header-outer' . esc_attr( $hew_col_number ) . '">';

		} else {

			echo '<div id="' . esc_attr( $this->id ) . '">';

		}

		$defaults = array( 'count' => 20 );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$count = apply_filters( 'widget_title', $instance['count'] );

		if ( !empty( $count ) ) {

			/* function */

			?>

			<div style="height: <?php echo esc_attr( $count ); ?>px;"></div>

            <?php

			/* */

		}

		echo '</div>';

	}

}

/* metz_customFacebookFindUsWidget Class */
class metz_customFacebookFindUsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'metz_customFacebookFindUsWidget',
			'Metz Widget: Find us on Facebook',
			array( 'description' => "Show your Facebook page's lovers." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'page' => 'coldplay', 'height' => '400', 'faces' => 'on', 'posts' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

		<p>Facebook page username: <input name="<?php echo esc_attr( $this->get_field_name( 'page' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['page'] ); ?>" style="width: 100%;" /></p>
        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'height' ) ); ?>">Height <em>(min. 70)</em> :</label>
		<input id="<?php echo esc_attr( $this->get_field_id( 'height' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'height' ) ); ?>" size="3" value="<?php echo esc_attr( $instance['height'] ); ?>" style="width: 50px;" />
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['faces'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'faces' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'faces' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'faces' ) ); ?>">Show Friend's Faces <em>("Height" value must be at least 215.)</em></label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['posts'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'posts' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'posts' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'posts' ) ); ?>">Show Page Posts <em>("Height" value must be at least 300.)</em></label>
		</p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['page'] = ( !empty( $new_instance['page'] ) ) ? strip_tags( $new_instance['page'] ) : 'coldplay';
		$instance['height'] = ( !empty( $new_instance['height'] ) ) ? strip_tags( $new_instance['height'] ) : '400';
		$instance['faces'] = $new_instance['faces'];
		$instance['posts'] = $new_instance['posts'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		global $id;

		extract( $args );

		if ( $id == 'brnhmbx_footer_widgets' ) {

			$fw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColFooter', 1 ) ) { $fw_col_number = '-col2'; }
			echo '<div class="widget-item-footer-outer' . esc_attr( $fw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_home_widgets' ) {

			$hw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColHome', 0 ) ) { $hw_col_number = '-col2'; }
			if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) { $hw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-home-outer' . esc_attr( $hw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_upper_widgets' ) {

			$uw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColUpper', 0 ) ) { $uw_col_number = '-col2'; }
			if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) { $uw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-upper-outer' . esc_attr( $uw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_header_widgets' ) {

			$hew_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_headerWidgetsCol', 0 ) ) { $hew_col_number = '-col2'; }
			echo '<div class="widget-item-header-outer' . esc_attr( $hew_col_number ) . '">';

		} else {

			echo '<div id="' . esc_attr( $this->id ) . '">';

		}

		$defaults = array( 'page' => 'coldplay', 'height' => '400', 'faces' => 'on', 'posts' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$page = apply_filters( 'widget_title', $instance['page'] );
		$height = $instance['height'];
		$faces = $instance['faces'] ? 'true' : 'false';
		$posts = $instance['posts'] ? 'true' : 'false';

		if ( !empty( $page ) ) {

			/* function */

			?>

			<div id="fb-root"></div>
			<script>(function(d, s, id) {
              var js, fjs = d.getElementsByTagName(s)[0];
              if (d.getElementById(id)) return;
              js = d.createElement(s); js.id = id;
			  <?php
			  $facebook_sdk_language = '';
			  if ( get_theme_mod( 'metz_ignorePot', 1 ) && get_theme_mod( 'brnhmbx_tra_Lang' ) ) { $facebook_sdk_language = esc_attr( get_theme_mod( 'brnhmbx_tra_Lang' ) ); } else { $facebook_sdk_language = get_bloginfo( 'language' ); }
			  ?>
			  js.src = "//connect.facebook.net/" + "<?php echo str_replace( '-', '_', $facebook_sdk_language ); ?>" + "/sdk.js#xfbml=1&version=v2.4";
              fjs.parentNode.insertBefore(js, fjs);
            }(document, 'script', 'facebook-jssdk'));</script>

            <div class="fb-page" data-href="https://www.facebook.com/<?php echo esc_attr( $page ); ?>" data-width="260" data-height="<?php echo esc_attr( $height ); ?>" data-small-header="false" data-adapt-container-width="true" data-hide-cover="false" data-show-facepile="<?php if ( $faces == 'true' ) { echo 'true'; } else { echo 'false'; } ?>" data-show-posts="<?php if ( $posts == 'true' ) { echo 'true'; } else { echo 'false'; } ?>"><div class="fb-xfbml-parse-ignore"></div></div>

            <?php

			/* */

		}

		echo '</div>';

	}

}

/* metz_customImageWidget Class */
class metz_customImageWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'metz_customImageWidget',
			'Metz Widget: Image',
			array( 'description' => "Go ahead and place a nice image with a header, button, caption and text. You can link it to anywhere too." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'SIT AMET VULTATUP', 'text' => 'LOREM IPSUM DOLOR', 'headline' => 'DUIS ATEM VUL', 'btn_text' => 'DISCOVER NOW', 'path' => '', 'link' => '', 'target' => 'off', 'w_title_color' => '#FFF', 'box_color' => '#e93a56', 'headline_color' => '#999', 'text_color' => '#000', 'btn_text_color' => '#000', 'btn_bg_color' => '#FFF', 'btn_bo_color' => '#000', 'background_color' => '#FFF', 'bottom_sdw_color' => '#dadada', 'iwioi_color' => '#000', 'height' => '110', 'range' => '100', 'use_complex' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <script type='text/javascript'>

            jQuery( document ).ready( function($) {

				 $('.iwt-color-picker').wpColorPicker( {

		            defaultColor: '#FFF',
					change: _.throttle( function() { $('.iwt-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				 $('.iwbox-color-picker').wpColorPicker( {

		            defaultColor: '#e93a56',
					change: _.throttle( function() { $('.iwbox-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				 $('.iwh-color-picker').wpColorPicker( {

		            defaultColor: '#999',
					change: _.throttle( function() { $('.iwh-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				 $('.iwtxt-color-picker').wpColorPicker( {

		            defaultColor: '#000',
					change: _.throttle( function() { $('.iwtxt-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				 $('.iwbtxt-color-picker').wpColorPicker( {

		            defaultColor: '#000',
					change: _.throttle( function() { $('.iwbtxt-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				 $('.iwbbg-color-picker').wpColorPicker( {

		            defaultColor: '#FFF',
					change: _.throttle( function() { $('.iwbbg-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				 $('.iwbbo-color-picker').wpColorPicker( {

		            defaultColor: '#000',
					change: _.throttle( function() { $('.iwbbo-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				 $('.iwb-color-picker').wpColorPicker( {

		            defaultColor: '#FFF',
					change: _.throttle( function() { $('.iwb-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				 $('.iwbsdw-color-picker').wpColorPicker( {

		            defaultColor: '#dadada',
					change: _.throttle( function() { $('.iwbsdw-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				$('.iwioi-color-picker').wpColorPicker( {

		            defaultColor: '#000',
					change: _.throttle( function() { $('.iwioi-color-picker').trigger( 'change' ) }, 3000 ),

				} );

            } );

        </script>

        <p>Image Path: <input name="<?php echo esc_attr( $this->get_field_name( 'path' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['path'] ); ?>" style="width: 100%;" /></p>
        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'iwioi_color' ) ); ?>">Use Color Instead of Image:<br /><em>Only used if "Image Path" is blank and "Use Complex View" is unchecked.</em></label><br />
		<input class="iwioi-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'iwioi_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'iwioi_color' ) ); ?>" value="<?php echo esc_attr( $instance['iwioi_color'] ); ?>" />
        </p>
        <p>Height (<em>Only used if "Image Path" is blank</em>) :
		<input id="<?php echo esc_attr( $this->get_field_id( 'height' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'height' ) ); ?>" size="3" value="<?php echo esc_attr( $instance['height'] ); ?>" style="width: 50px;" />
		</p>
        <p>Link: <input name="<?php echo esc_attr( $this->get_field_name( 'link' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['link'] ); ?>" style="width: 100%;" /></p>
        <p>
		<input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['target'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'target' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'target' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'target' ) ); ?>">Open in new window</label>
		</p>
		<p>Title: <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>
        <p>Headline: <input name="<?php echo esc_attr( $this->get_field_name( 'headline' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['headline'] ); ?>" style="width: 100%;" /></p>
        <p>Text: <textarea name="<?php echo esc_attr( $this->get_field_name( 'text' ) ); ?>" rows="3" style="width: 100%; resize: none;"><?php echo esc_attr( $instance['text'] ); ?></textarea></p>
        <p>Button Text <em>(Leave blank to hide the button)</em>: <input name="<?php echo esc_attr( $this->get_field_name( 'btn_text' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['btn_text'] ); ?>" style="width: 100%;" /></p>
        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['use_complex'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'use_complex' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'use_complex' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'use_complex' ) ); ?>">Use Complex View</label>
		</p>
        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'w_title_color' ) ); ?>">Title Color:</label><br />
		<input class="iwt-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'w_title_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'w_title_color' ) ); ?>" value="<?php echo esc_attr( $instance['w_title_color'] ); ?>" />
        </p>
        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'box_color' ) ); ?>">Box Color:</label><br />
		<input class="iwbox-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'box_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'box_color' ) ); ?>" value="<?php echo esc_attr( $instance['box_color'] ); ?>" />
        </p>
        <p>Box Opacity:<br />
        <input name="<?php echo esc_attr( $this->get_field_name( 'range' ) ); ?>" type="range" min="0" max="100" step="10" value="<?php echo esc_attr( $instance['range'] ); ?>" />
        </p>
        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'headline_color' ) ); ?>">Headline Color:</label><br />
		<input class="iwh-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'headline_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'headline_color' ) ); ?>" value="<?php echo esc_attr( $instance['headline_color'] ); ?>" />
        </p>
        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>">Text Color:</label><br />
		<input class="iwtxt-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'text_color' ) ); ?>" value="<?php echo esc_attr( $instance['text_color'] ); ?>" />
        </p>
        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'btn_text_color' ) ); ?>">Button Text Color:</label><br />
		<input class="iwbtxt-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'btn_text_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'btn_text_color' ) ); ?>" value="<?php echo esc_attr( $instance['btn_text_color'] ); ?>" />
        </p>
        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'btn_bg_color' ) ); ?>">Button Background Color:</label><br />
		<input class="iwbbg-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'btn_bg_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'btn_bg_color' ) ); ?>" value="<?php echo esc_attr( $instance['btn_bg_color'] ); ?>" />
        </p>
        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'btn_bo_color' ) ); ?>">Button Border Color:</label><br />
		<input class="iwbbo-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'btn_bo_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'btn_bo_color' ) ); ?>" value="<?php echo esc_attr( $instance['btn_bo_color'] ); ?>" />
        </p>
        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>">Background Color:</label><br />
		<input class="iwb-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'background_color' ) ); ?>" value="<?php echo esc_attr( $instance['background_color'] ); ?>" />
        </p>
        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'bottom_sdw_color' ) ); ?>">Bottom Shadow Color:</label><br />
		<input class="iwbsdw-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'bottom_sdw_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'bottom_sdw_color' ) ); ?>" value="<?php echo esc_attr( $instance['bottom_sdw_color'] ); ?>" />
        </p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

	    $instance['name'] = $new_instance['name'];
		$instance['text'] = $new_instance['text'];
		$instance['headline'] = $new_instance['headline'];
		$instance['btn_text'] = $new_instance['btn_text'];
		$instance['path'] = $new_instance['path'];
		$instance['link'] = $new_instance['link'];
		$instance['target'] = $new_instance['target'];
		$instance['w_title_color'] = $new_instance['w_title_color'];
		$instance['box_color'] = $new_instance['box_color'];
		$instance['headline_color'] = $new_instance['headline_color'];
		$instance['text_color'] = $new_instance['text_color'];
		$instance['btn_text_color'] = $new_instance['btn_text_color'];
		$instance['btn_bg_color'] = $new_instance['btn_bg_color'];
		$instance['btn_bo_color'] = $new_instance['btn_bo_color'];
		$instance['background_color'] = $new_instance['background_color'];
		$instance['bottom_sdw_color'] = $new_instance['bottom_sdw_color'];
		$instance['iwioi_color'] = $new_instance['iwioi_color'];
		$instance['height'] = $new_instance['height'];
		$instance['range'] = $new_instance['range'];
		$instance['use_complex'] = $new_instance['use_complex'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		if ( $id == 'brnhmbx_footer_widgets' ) {

			$fw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColFooter', 1 ) ) { $fw_col_number = '-col2'; }
			echo '<div class="widget-item-footer-outer' . esc_attr( $fw_col_number ) . '" style="text-align: center;">';

		} else if ( $id == 'brnhmbx_home_widgets' ) {

			$hw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColHome', 0 ) ) { $hw_col_number = '-col2'; }
			if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) { $hw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-home-outer' . esc_attr( $hw_col_number ) . '" style="text-align: center;">';

		} else if ( $id == 'brnhmbx_upper_widgets' ) {

			$uw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColUpper', 0 ) ) { $uw_col_number = '-col2'; }
			if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) { $uw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-upper-outer' . esc_attr( $uw_col_number ) . '" style="text-align: center;">';

		} else if ( $id == 'brnhmbx_header_widgets' ) {

			$hew_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_headerWidgetsCol', 0 ) ) { $hew_col_number = '-col2'; }
			echo '<div class="widget-item-header-outer' . esc_attr( $hew_col_number ) . '" style="text-align: center;">';

		} else {

			echo '<div id="' . esc_attr( $this->id ) . '">';

		}

		$defaults = array( 'name' => 'SIT AMET VULTATUP', 'text' => 'LOREM IPSUM DOLOR', 'headline' => 'DUIS ATEM VUL', 'btn_text' => 'DISCOVER NOW', 'path' => '', 'link' => '', 'target' => 'off', 'w_title_color' => '#FFF', 'box_color' => '#e93a56', 'headline_color' => '#999', 'text_color' => '#000', 'btn_text_color' => '#000', 'btn_bg_color' => '#FFF', 'btn_bo_color' => '#000', 'background_color' => '#FFF', 'bottom_sdw_color' => '#dadada', 'iwioi_color' => '#000', 'height' => '110', 'range' => '100', 'use_complex' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$name = apply_filters( 'widget_title', $instance['name'] );
		$text = $instance['text'];
		$headline = $instance['headline'];
		$btn_text = $instance['btn_text'];
		$path = $instance['path'];
		$link = $instance['link'];
		$target = $instance['target'] ? 'true' : 'false';
		$w_title_color = $instance['w_title_color'];
		$box_color = $instance['box_color'];
		$headline_color = $instance['headline_color'];
		$text_color = $instance['text_color'];
		$btn_text_color = $instance['btn_text_color'];
		$btn_bg_color = $instance['btn_bg_color'];
		$btn_bo_color = $instance['btn_bo_color'];
		$background_color = $instance['background_color'];
		$bottom_sdw_color = $instance['bottom_sdw_color'];
		$iwioi_color = $instance['iwioi_color'];
		$height = $instance['height'];
		$range = $instance['range'];
		$use_complex = $instance['use_complex'] ? 'true' : 'false';

		/* */

		$iw_rand = rand( 1, 9999999 ); ?>

        <style type="text/css" scoped>

			<?php echo esc_attr( '.iw-' . $iw_rand ); ?>.widget-listing-a-b.zig-zag:after { background-color: <?php echo esc_attr( $bottom_sdw_color ); ?>; }

			<?php echo esc_attr( '.iw-' . $iw_rand ); ?>.widget-listing-a-b div.image-widget-title-outer .image-widget-title,
			.image-widget-wrapper div.image-widget-content .image-widget-inner .table-cell-middle,
			<?php echo esc_attr( '.iw-' . $iw_rand ); ?>.widget-listing-a-b a > div.image-widget-title-outer .image-widget-title,
			<?php echo esc_attr( '.iw-' . $iw_rand ); ?>.widget-listing-a-b a:visited > div.image-widget-title-outer .image-widget-title,
			.image-widget-wrapper a > div.image-widget-content .image-widget-inner .table-cell-middle <?php echo esc_attr( '.iw-' . $iw_rand ); ?>.image-widget-title,
			.image-widget-wrapper a:visited > div.image-widget-content .image-widget-inner .table-cell-middle <?php echo esc_attr( '.iw-' . $iw_rand ); ?>.image-widget-title { background: rgba(<?php echo esc_attr( metz_hex2rgb( $box_color ) ) . ',' . esc_attr( $range ) / 100; ?>); color: <?php echo esc_attr( $w_title_color ); ?>; -webkit-transition: all 0.3s ease-out; transition: all 0.3s ease-out; }

			<?php echo esc_attr( '.iw-' . $iw_rand ); ?>.widget-listing-a-b a:hover > div.image-widget-title-outer .image-widget-title,
			.image-widget-wrapper a:hover > div.image-widget-content .image-widget-inner .table-cell-middle <?php echo esc_attr( '.iw-' . $iw_rand ); ?>.image-widget-title { background: rgba(<?php echo esc_attr( metz_hex2rgb( $w_title_color ) ) . ', 1'; ?>); color: <?php echo esc_attr( $box_color ); ?>; }

			<?php echo esc_attr( '.iw-' . $iw_rand ); ?>.widget-listing-a-b div.image-widget-btn span,
			<?php echo esc_attr( '.iw-' . $iw_rand ); ?>.widget-listing-a-b a > div.image-widget-btn span,
			<?php echo esc_attr( '.iw-' . $iw_rand ); ?>.widget-listing-a-b a:visited > div.image-widget-btn span { border-color: <?php echo esc_attr( $btn_bo_color ); ?>; background-color: <?php echo esc_attr( $btn_bg_color ); ?>; color: <?php echo esc_attr( $btn_text_color ); ?>; -webkit-transition: all 0.3s ease-out; transition: all 0.3s ease-out; }

			<?php echo esc_attr( '.iw-' . $iw_rand ); ?>.widget-listing-a-b a:hover > div.image-widget-btn span { background-color: <?php echo esc_attr( $btn_text_color ); ?>; color: <?php echo esc_attr( $btn_bg_color ); ?>; }

		</style>

        <?php

		/* function */

		if ( $use_complex == 'true' ) { ?>

            <div class="clearfix <?php echo esc_attr( 'iw-' . $iw_rand ); ?> widget-listing-a-b<?php if ( $headline || $text || $btn_text ) { echo ' zig-zag" style="background-color: ' . esc_attr( $background_color ) . ';"'; } else { echo '"'; } ?>>

                <?php if ( $link ) { echo '<a href="' . esc_attr( $link ) . '" target="'; if ( $target == 'true' ) { echo '_blank'; } else { echo '_self'; } echo '">'; } ?>
                <?php if ( $path ) { ?><div<?php if ( $headline || $text || $btn_text ) { echo ' class="image-widget-img"'; } ?>><img alt="img-alt" src="<?php echo esc_attr( $path ); ?>" /></div><?php } else { echo '<div style="min-height: 30px; height: ' . esc_attr( $height ) . 'px;"></div>'; } ?>

                <?php if ( $name ) { ?>
                    <div class="image-widget-title-outer playfair">
                        <div class="image-widget-title"><?php echo esc_attr( $name ); ?></div>
                    </div>
                <?php } ?>

                <?php if ( $headline ) { ?><div class="montserrat image-widget-headline" style="color: <?php echo esc_attr( $headline_color ); ?>;<?php if ( !$text ) { echo ' margin-bottom: 20px;'; } ?>"><?php echo esc_attr( $headline ); ?></div><?php } ?>
                <?php if ( $text ) { ?><div class="playfair image-widget-text" style="color: <?php echo esc_attr( $text_color ); ?>;"><?php echo esc_attr( $text ); ?></div><?php } ?>
                <?php if ( $btn_text ) { ?><div class="montserrat image-widget-btn"><span><?php echo esc_attr( $btn_text ); ?></span></div><?php } ?>
                <?php if ( $link ) { echo '</a>'; } ?>

            </div>

		<?php } else { ?>

            <div class="image-widget-wrapper"><?php if ( $link ) { echo '<a href="' . esc_attr( $link ) . '" target="'; if ( $target == 'true' ) { echo '_blank'; } else { echo '_self'; } echo '">'; } ?>

            <?php if ( $path ) { ?><img alt="img-alt" src="<?php echo esc_attr( $path ); ?>" /><?php } ?>

            <?php if ( $name ) { ?>
                <div class="image-widget-content" <?php if ( !$path ) { echo 'style="background-color: ' . esc_attr( $iwioi_color ) . '; width: 100%;"'; } ?>>
                    <div class="image-widget-inner" <?php if ( !$path ) { echo 'style="height: ' . esc_attr( $height ) . 'px;"'; } ?>>
                        <div class="table-cell-middle" <?php echo 'style="color: ' . esc_attr( $w_title_color ) . ';"' ?>>
                            <div class="fs16 playfair image-widget-title<?php echo esc_attr( ' iw-' . $iw_rand ); ?>"><?php echo esc_attr( $name ); ?></div>
                        </div>
                    </div>
                </div>
            <?php } ?>

            <?php if ( $link ) { echo '</a>'; } ?></div>

        <?php } ?>

		<?php

		/* */

		echo '</div>';

	}

}

/* metz_customPopularPostsWidget */
class metz_customPopularPostsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'metz_customPopularPostsWidget',
			'Metz Widget: Popular Posts',
			array( 'description' => "Some posts are crowded ha? This widget will find and display them." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'POPULAR POSTS', 'opt_hdr' => 'OPTIONAL HEADLINE', 'count' => 5, 'styleB_count' => 1, 'styleC_count' => 3, 'date' => 'on', 'comments' => 'on', 'hits' => 'on', 'comment_based' => 'on', 'day_limit' => 'on', 'text_color' => '#57818d', 'background_color' => '#e5ecee', 'range' => '100' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <script type='text/javascript'>

            jQuery( document ).ready( function($) {

                $('.ppw-bg-color-picker').wpColorPicker( {

		            defaultColor: '#e5ecee',
					change: _.throttle( function() { $('.ppw-bg-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				$('.ppw-t-color-picker').wpColorPicker( {

		            defaultColor: '#57818d',
					change: _.throttle( function() { $('.ppw-t-color-picker').trigger( 'change' ) }, 3000 ),

				} );

            } );

        </script>

		<p>Title: <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>
        <p>Optional Headline: <input name="<?php echo esc_attr( $this->get_field_name( 'opt_hdr' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['opt_hdr'] ); ?>" style="width: 100%;" /></p>
        <p>Number of posts to show: <input name="<?php echo esc_attr( $this->get_field_name( 'count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['count'] ); ?>" style="width: 50px;" /></p>
        <p><em>The default post style is "Style A".</em></p>
        <p>Post count for "Style B": <input name="<?php echo esc_attr( $this->get_field_name( 'styleB_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleB_count'] ); ?>" style="width: 50px;" /></p>
        <p>Post count for "Style C": <input name="<?php echo esc_attr( $this->get_field_name( 'styleC_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleC_count'] ); ?>" style="width: 50px;" /></p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['date'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'date' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>">Display post date?</label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['comments'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'comments' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'comments' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'comments' ) ); ?>">Display comments icon?</label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['hits'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'hits' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'hits' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'hits' ) ); ?>">Display visitor hits?</label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['comment_based'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'comment_based' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'comment_based' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'comment_based' ) ); ?>">Comment Based Popularity</label>
        <br><em>Uncheck for "View Based Popularity".</em>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['day_limit'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'day_limit' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'day_limit' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'day_limit' ) ); ?>">Include last 60 days only</label>
		</p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>">Box Color:</label>
		<br />
		<input class="ppw-bg-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'background_color' ) ); ?>" value="<?php echo esc_attr( $instance['background_color'] ); ?>" />
        </p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>">Link Color:</label>
		<br />
		<input class="ppw-t-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'text_color' ) ); ?>" value="<?php echo esc_attr( $instance['text_color'] ); ?>" />
        </p>

        <p>Box Opacity:<br />
        <input name="<?php echo esc_attr( $this->get_field_name( 'range' ) ); ?>" type="range" min="0" max="100" step="10" value="<?php echo esc_attr( $instance['range'] ); ?>" />
        </p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['name'] = ( !empty( $new_instance['name'] ) ) ? strip_tags( $new_instance['name'] ) : 'POPULAR POSTS';
		$instance['opt_hdr'] = $new_instance['opt_hdr'];
		$instance['count'] = ( !empty( $new_instance['count'] ) ) ? strip_tags( $new_instance['count'] ) : '5';
		$instance['styleB_count'] = $new_instance['styleB_count'];
		$instance['styleC_count'] = $new_instance['styleC_count'];
		$instance['date'] = $new_instance['date'];
		$instance['comments'] = $new_instance['comments'];
		$instance['hits'] = $new_instance['hits'];
		$instance['comment_based'] = $new_instance['comment_based'];
		$instance['day_limit'] = $new_instance['day_limit'];
		$instance['text_color'] = $new_instance['text_color'];
		$instance['background_color'] = $new_instance['background_color'];
		$instance['range'] = $new_instance['range'];

		return $instance;

	}

	// Limit to last 30 days
	function filter_where( $where = '' ) {

		$where .= " AND post_date > '" . date( 'Y-m-d', strtotime( '-' . 30 .' days' ) ) . "'";
		return $where;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'name' => 'POPULAR POSTS', 'opt_hdr' => 'OPTIONAL HEADLINE', 'count' => 5, 'styleB_count' => 1, 'styleC_count' => 3, 'date' => 'on', 'comments' => 'on', 'hits' => 'on', 'comment_based' => 'on', 'day_limit' => 'on', 'text_color' => '#57818d', 'background_color' => '#e5ecee', 'range' => '100' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$name = apply_filters( 'widget_title', $instance['name'] );
		$opt_hdr = $instance['opt_hdr'];
		$count = $instance['count'];
		$styleB_count = $instance['styleB_count'];
		$styleC_count = $instance['styleC_count'];
		$date = $instance['date'] ? 'true' : 'false';
		$comments = $instance['comments'] ? 'true' : 'false';
		$hits = $instance['hits'] ? 'true' : 'false';
		$comment_based = $instance['comment_based'] ? 'true' : 'false';
		$day_limit = $instance['day_limit'] ? 'true' : 'false';
		$text_color = $instance['text_color'];
		$background_color = $instance['background_color'];
		$range = $instance['range'];

		/* Combine Widget Listing Settings */

		$w_listing_style = 'a';
		$w_listingOrder = 0;

		if ( $styleB_count + $styleC_count > $count ) {

			$styleB_count = 0;
			$styleC_count = 0;

		}

		/* */

		$ppw_rand = rand( 1, 9999999 ); ?>

        <style type="text/css" scoped>

			<?php echo esc_attr( 'a.ppw-' . $ppw_rand ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.ppw-' . $ppw_rand . ':visited' ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.ppw-' . $ppw_rand ); ?> div.related-post-item-header-a .rpih-inner-a,
			<?php echo esc_attr( 'a.ppw-' . $ppw_rand . ':visited' ); ?> div.related-post-item-header-a .rpih-inner-a,
			<?php echo esc_attr( 'a.ppw-' . $ppw_rand ); ?> div.related-post-item-header-b .rpih-inner-b,
			<?php echo esc_attr( 'a.ppw-' . $ppw_rand . ':visited' ); ?> div.related-post-item-header-b .rpih-inner-b,
			<?php echo esc_attr( 'a.ppw-' . $ppw_rand ); ?>,
			<?php echo esc_attr( 'a.ppw-' . $ppw_rand ); ?> div.widget-listing-c { background: rgba(<?php echo esc_attr( metz_hex2rgb( $background_color ) ) . ',' . esc_attr( $range ) / 100; ?>); color: <?php echo esc_attr( $text_color ); ?>; -webkit-transition: all 0.3s ease-out; transition: all 0.3s ease-out; }
			<?php echo esc_attr( 'a.ppw-' . $ppw_rand . ':hover' ); ?>,
			<?php echo esc_attr( 'a.ppw-' . $ppw_rand . ':hover' ); ?> div.widget-listing-c,
			<?php echo esc_attr( 'a.ppw-' . $ppw_rand . ':hover' ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.ppw-' . $ppw_rand . ':hover' ); ?> div.related-post-item-header-a .rpih-inner-a,
			<?php echo esc_attr( 'a.ppw-' . $ppw_rand . ':hover' ); ?> div.related-post-item-header-b .rpih-inner-b { background: rgba(<?php echo esc_attr( metz_hex2rgb( $text_color ) ) . ', 1'; ?>); color: <?php echo esc_attr( $background_color ); ?>; }

		</style>

        <?php

		if ( !empty( $name ) ) {

			echo wp_kses_post( $before_title ) . esc_attr( $name ) . wp_kses_post( $after_title ) . '<div class="montserrat widget-item-opt-hdr">' . esc_attr( $opt_hdr ) . '</div>';

			/* function */

			if ( $comment_based == 'true' ) {

				$loop_args = array(

					'posts_per_page' => esc_attr( $count ),
					'orderby' => 'comment_count',
					'ignore_sticky_posts' => 1

				);

			} else {

				$loop_args = array(

					'posts_per_page' => esc_attr( $count ),
					'orderby'   => 'meta_value_num',
					'meta_key'  => 'post_views_count',
					'ignore_sticky_posts' => 1

				);

			}

			if ( $day_limit == 'true' ) { add_filter( 'posts_where', array( $this, 'filter_where' ) ); }
			$loop = new WP_Query( $loop_args );
			if ( $day_limit == 'true' ) { remove_filter( 'posts_where', array( $this, 'filter_where' ) ); }

			while( $loop->have_posts() ) : $loop->the_post();

			//Combine Widget Listing Settings Styles

			$w_listingOrder ++;

			if ( $styleB_count > 0 && ( $w_listingOrder > $count - ( $styleB_count + $styleC_count ) && $w_listingOrder <= $count - $styleC_count ) ) {

				$w_listing_style = 'b';

			}

			if ( $styleC_count > 0 && ( $w_listingOrder > $count - $styleC_count ) ) {

				$w_listing_style = 'c';

			}

			if ( $w_listing_style == 'a' || $w_listing_style == 'b' ) { ?>

                <div class="clearfix widget-listing-a-b box-a-wi">

                	<?php if ( $date == 'true' || ( $comments == 'true' && comments_open() ) || $hits == 'true' ) { ?>

                        <div class="montserrat clearfix widget-date-bar">

                            <?php if ( $date == 'true' ) { ?>

                                <div class="left"><?php echo '<a href="' . esc_url( get_the_permalink() ) . '" class="date-a">' . get_the_date() . '</a>' ?></div>

                            <?php } ?>

                                <div class="right">

                                    <?php if ( $comments == 'true' && comments_open() ) { ?>

                                        <a href="<?php esc_url( the_permalink() ); ?>#comments"><i class="fa fa-comment-o i-spcr-r clock"></i><?php comments_number( '0 ', '1 ', '% ' ); ?></a><?php } ?>

                                        <?php if ( $hits == 'true' ) { ?><i class="fa fa-bolt i-spcr-r <?php if ( $comments == 'true' && comments_open() ) { echo 'i-spcr-l2'; } ?> clock"></i><?php echo metz_getPostViews( get_the_ID() ); } ?>

                                </div>

                        </div>

                    <?php } ?>

                    <a class="<?php echo esc_attr( 'ppw-' . $ppw_rand ); ?>" href="<?php esc_url( the_permalink() ); ?>">
                        <?php if ( has_post_thumbnail() ) { ?><div><?php the_post_thumbnail( 'related-thumbnail' ); ?></div><?php } else if ( $w_listing_style == 'a' ) { ?><div class="rp-a-without-image"></div><?php } ?>
                        <div class="related-post-item-header-<?php echo esc_attr( $w_listing_style ); ?> playfair">
							<div class="rpih-inner-<?php echo esc_attr( $w_listing_style ); ?>">
                            	<div class="rpih-text-<?php echo esc_attr( $w_listing_style ); ?>"><?php the_title(); ?></div>
                            </div>
                        </div>
                    </a>
                </div>

			<?php } else if ( $w_listing_style == 'c' ) { ?>

                <a class="<?php echo esc_attr( 'ppw-' . $ppw_rand ); ?>" href="<?php esc_url( the_permalink() ); ?>">
                	<div class="widget-listing-c clearfix">
						<?php if ( has_post_thumbnail() ) { ?><div><?php echo the_post_thumbnail( 'page-navigation-thumbnail' ); ?></div><?php } ?>
						<div class="widget-listing-c-info <?php if ( has_post_thumbnail() ) { echo 'widget-listing-c-info-with-t'; } ?>">
							<div class="table-cell-middle"><span class="playfair widget-listing-c-title"><?php the_title(); ?></span></div>
						</div>
                	</div>
                </a>

			<?php } ?>

			<?php endwhile;

			wp_reset_postdata();

			/* */

		}

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

/* metz_customPostWidget Class */
class metz_customPostWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'metz_customPostWidget',
			'Metz Widget: Post',
			array( 'description' => "Maybe you want some special attention for one of your posts. Use this!" )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'date' => 'on', 'comments' => 'on', 'hits' => 'on', 'target' => 'off', 'text_color' => '#FFF', 'background_color' => '#b75250', 'range' => '80', 'post_1' => '0', 'style_B' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <script type='text/javascript'>

            jQuery( document ).ready( function($) {

                $('.pw-bg-color-picker').wpColorPicker( {

		            defaultColor: '#b75250',
					change: _.throttle( function() { $('.pw-bg-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				$('.pw-t-color-picker').wpColorPicker( {

		            defaultColor: '#FFF',
					change: _.throttle( function() { $('.pw-t-color-picker').trigger( 'change' ) }, 3000 ),

				} );

            } );

        </script>

        <p>Post ID: <input id="get-dropdown-val-1-p" name="<?php echo esc_attr( $this->get_field_name( 'post_1' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['post_1'] ); ?>" style="width: 50px;" /></p>
        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['date'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'date' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>">Display post date?</label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['comments'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'comments' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'comments' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'comments' ) ); ?>">Display comments icon?</label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['hits'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'hits' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'hits' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'hits' ) ); ?>">Display visitor hits?</label>
		</p>

        <p>
		<input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['target'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'target' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'target' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'target' ) ); ?>">Open in new window</label>
		</p>

        <p><em>The default listing style is "Style A".</em><br />
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['style_B'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'style_B' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'style_B' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'style_B' ) ); ?>">Use "Style B"</label>
		</p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>">Box Color:</label>
		<br />
		<input class="pw-bg-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'background_color' ) ); ?>" value="<?php echo esc_attr( $instance['background_color'] ); ?>" />
        </p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>">Link Color:</label>
		<br />
		<input class="pw-t-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'text_color' ) ); ?>" value="<?php echo esc_attr( $instance['text_color'] ); ?>" />
        </p>

        <p>Box Opacity:<br />
        <input name="<?php echo esc_attr( $this->get_field_name( 'range' ) ); ?>" type="range" min="0" max="100" step="10" value="<?php echo esc_attr( $instance['range'] ); ?>" />
        </p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['date'] = $new_instance['date'];
		$instance['comments'] = $new_instance['comments'];
		$instance['hits'] = $new_instance['hits'];
		$instance['target'] = $new_instance['target'];
		$instance['text_color'] = $new_instance['text_color'];
		$instance['background_color'] = $new_instance['background_color'];
		$instance['range'] = $new_instance['range'];
		$instance['post_1'] = $new_instance['post_1'];
		$instance['style_B'] = $new_instance['style_B'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		if ( $id == 'brnhmbx_footer_widgets' ) {

			$fw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColFooter', 1 ) ) { $fw_col_number = '-col2'; }
			echo '<div class="widget-item-footer-outer' . esc_attr( $fw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_home_widgets' ) {

			$hw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColHome', 0 ) ) { $hw_col_number = '-col2'; }
			if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) { $hw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-home-outer' . esc_attr( $hw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_upper_widgets' ) {

			$uw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColUpper', 0 ) ) { $uw_col_number = '-col2'; }
			if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) { $uw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-upper-outer' . esc_attr( $uw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_header_widgets' ) {

			$hew_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_headerWidgetsCol', 0 ) ) { $hew_col_number = '-col2'; }
			echo '<div class="widget-item-header-outer' . esc_attr( $hew_col_number ) . '">';

		} else {

			echo '<div id="' . esc_attr( $this->id ) . '">';

		}

		$defaults = array( 'date' => 'on', 'comments' => 'on', 'hits' => 'on', 'target' => 'off', 'text_color' => '#FFF', 'background_color' => '#b75250', 'range' => '80', 'post_1' => '0', 'style_B' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$date = $instance['date'] ? 'true' : 'false';
		$comments = $instance['comments'] ? 'true' : 'false';
		$hits = $instance['hits'] ? 'true' : 'false';
		$target = $instance['target'] ? 'true' : 'false';
		$text_color = $instance['text_color'];
		$background_color = $instance['background_color'];
		$range = $instance['range'];
		$post_1 = $instance['post_1'];
		$style_B = $instance['style_B'] ? 'true' : 'false';

		if ( $style_B == 'true' ){

			$style = 'b';

		} else {

			$style = 'a';

		}

		$w_selectedCount = 0;

		if ( $post_1 != 0 && $post_1 != 999999 ) { $w_selectedCount++; }

		/* */

		$pw_rand = rand( 1, 9999999 ); ?>

        <style type="text/css" scoped>

			<?php echo esc_attr( 'a.pw-' . $pw_rand ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.pw-' . $pw_rand . ':visited' ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.pw-' . $pw_rand ); ?> div.related-post-item-header-a .rpih-inner-a,
			<?php echo esc_attr( 'a.pw-' . $pw_rand . ':visited' ); ?> div.related-post-item-header-a .rpih-inner-a { background: rgba(<?php echo esc_attr( metz_hex2rgb( $background_color ) ) . ',' . esc_attr( $range ) / 100; ?>); color: <?php echo esc_attr( $text_color ); ?>; -webkit-transition: all 0.3s ease-out; transition: all 0.3s ease-out; }
			<?php echo esc_attr( 'a.pw-' . $pw_rand . ':hover' ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.pw-' . $pw_rand . ':hover' ); ?> div.related-post-item-header-a .rpih-inner-a { background: rgba(<?php echo esc_attr( metz_hex2rgb( $text_color ) ) . ', 1'; ?>); color: <?php echo esc_attr( $background_color ); ?>; }

		</style>

        <?php

		if ( $w_selectedCount ) {

			/* function */

			$loop_args = array(

				'showposts' => 1,
				'post_type' => 'post',
				'post__in' => array( esc_attr( $post_1 ) ),
				'ignore_sticky_posts' => 1,
				'orderby' => 'post__in'

			);

			$rPosts = new WP_Query( $loop_args );

			while ( $rPosts->have_posts() ) : $rPosts->the_post(); ?>

                <div class="clearfix widget-listing-a-b box-a-wi">

					<?php if ( $style == 'a' ) {

                        if ( $date == 'true' || ( $comments == 'true' && comments_open() ) || $hits == 'true' ) { echo '<div class="montserrat clearfix widget-date-bar mb8">'; if ( $date == 'true' ) { echo '<div class="left"><a href="' . esc_url( get_the_permalink() ) . '" class="date-a">' . get_the_date() . '</a></div>'; } echo '<div class="right">'; if ( $comments == 'true' && comments_open() ) { echo '<a href="' . esc_url( get_the_permalink() ) . '#comments"><i class="fa fa-comment-o i-spcr-r clock"></i>'; comments_number( '0 ', '1 ', '% ' ); echo '</a>'; } if ( $hits == 'true' ) { echo '<i class="fa fa-bolt i-spcr-r '; if ( $comments == 'true' && comments_open() ) { echo 'i-spcr-l2 '; } echo 'clock"></i>'; echo metz_getPostViews( get_the_ID() ); } echo '</div></div>'; }

                    } ?>

                    <a class="<?php echo esc_attr( 'pw-' . $pw_rand ); ?>" href="<?php esc_url( the_permalink() ); ?>" target="<?php if ( $target == 'true' ) { echo '_blank'; } else { echo '_self'; } ?>">
                        <?php if ( has_post_thumbnail() ) { ?><div><?php if ( $style == 'b' ) { the_post_thumbnail(); } else { the_post_thumbnail( 'related-thumbnail' ); } ?></div><?php } else { ?><div class="rp-a-without-image<?php if ( $style == 'b' ) { echo ' w-i-b'; } ?>"></div><?php } ?>
                        <div class="related-post-item-header-a playfair<?php if ( $style == 'b' ) { echo ' ta-l-mb20'; } ?>">
							<div class="rpih-inner-a<?php if ( $style == 'b' ) { echo ' p20-ml20-mr20'; } ?>">

                            	 <?php if ( $style == 'b' ) {

									if ( $date == 'true' || ( $comments == 'true' && comments_open() ) || $hits == 'true' ) { echo '<div class="montserrat clearfix widget-date-bar-b">'; if ( $date == 'true' ) { echo '<div class="left">' . get_the_date() . '</div>'; } echo '<div class="right">'; if ( $comments == 'true' && comments_open() ) { echo '<i class="fa fa-comment-o i-spcr-r clock"></i>'; comments_number( '0 ', '1 ', '% ' ); } if ( $hits == 'true' ) { echo '<i class="fa fa-bolt i-spcr-r '; if ( $comments == 'true' && comments_open() ) { echo 'i-spcr-l2 '; } echo 'clock"></i>'; echo metz_getPostViews( get_the_ID() ); } echo '</div></div>'; }

								} ?>

                            	<div class="rpih-text-a<?php if ( $style == 'b' ) { echo ' mw220'; } ?>"><?php the_title(); ?></div>
                            </div>
                        </div>
                    </a>
                </div>

			<?php  endwhile;

			wp_reset_postdata();

			/* */

		}

		echo '</div>';

	}

}

/* metz_customRecentCommentsWidget Class */
class metz_customRecentCommentsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'metz_customRecentCommentsWidget',
			'Metz Widget: Recent Comments',
			array( 'description' => "Display the latest comments your visitors have dropped." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'LATEST COMMENTS', 'opt_hdr' => '', 'count' => 5, 'avatar' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

		<p>Title: <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>
        <p>Optional Headline: <input name="<?php echo esc_attr( $this->get_field_name( 'opt_hdr' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['opt_hdr'] ); ?>" style="width: 100%;" /></p>
        <p>Number of posts to show: <input name="<?php echo esc_attr( $this->get_field_name( 'count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['count'] ); ?>" style="width: 50px;" /></p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['avatar'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'avatar' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'avatar' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'avatar' ) ); ?>">Display avatar</label>
		</p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['name'] = ( !empty( $new_instance['name'] ) ) ? strip_tags( $new_instance['name'] ) : 'LATEST COMMENTS';
		$instance['opt_hdr'] = $new_instance['opt_hdr'];
		$instance['count'] = ( !empty( $new_instance['count'] ) ) ? strip_tags( $new_instance['count'] ) : '5';
		$instance['avatar'] = $new_instance['avatar'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'name' => 'LATEST COMMENTS', 'opt_hdr' => '', 'count' => 5, 'avatar' => 'on' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		echo '<div class="recent-comments">';

		$name = apply_filters( 'widget_title', $instance['name'] );
		$opt_hdr = $instance['opt_hdr'];
		$count = $instance['count'];
		$avatar = $instance['avatar'] ? 'true' : 'false';

		if ( !empty( $name ) ) {

			echo wp_kses_post( $before_title ) . esc_attr( $name ) . wp_kses_post( $after_title ) . '<div class="montserrat widget-item-opt-hdr">' . esc_attr( $opt_hdr ) . '</div>';

			/* function */

			$avatar_size = 40;

			$approvedCounter = 0;

			$comments_query = new WP_Comment_Query();
			$comments = $comments_query->query( array( 'number' => 50 ) );

			if ( $comments ) {

				foreach( $comments as $comment ) {

					if ( $comment->comment_approved == '1' && $approvedCounter < $count && !post_password_required( $comment->comment_post_ID ) ) {

						$approvedCounter ++;

						$link = get_permalink( $comment->comment_post_ID ) . '#comment-' . esc_attr( $comment->comment_ID );
                        $title = get_the_title( $comment->comment_post_ID ); ?>

                        <div class="recent-comment-item clearfix">

                            <?php if ( $avatar == 'true' && get_option( 'show_avatars' ) ) { ?><div class="recent-comment-img"><a href="<?php echo esc_url ( $link ); ?>"><?php echo get_avatar( $comment->comment_author_email, $avatar_size ); ?></a></div><?php } ?>

                            <div class="left">

                                <div class="recent-comment-hdr montserrat"><a href="<?php echo esc_url ( $link ); ?>"><?php echo esc_attr ( $title ); ?></a></div>
                                <div class="recent-comment-author playfair"><?php echo get_comment_author( $comment->comment_ID ); ?></div>

                            </div>

                        </div>

					<?php }

				}

			}

			/* */

		}

		echo '</div>';

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

/* metz_customRecentPostsWidget Class */
class metz_customRecentPostsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'metz_customRecentPostsWidget',
			'Metz Widget: Recent Posts',
			array( 'description' => "Display a couple or two of your latest posts." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'LATEST POSTS', 'opt_hdr' => 'OPTIONAL HEADLINE', 'count' => 5, 'styleB_count' => 1, 'styleC_count' => 3, 'date' => 'on', 'recent' => 'on', 'comments' => 'on', 'hits' => 'on', 'text_color' => '#57818d', 'background_color' => '#e5ecee', 'range' => '100' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <script type='text/javascript'>

            jQuery( document ).ready( function($) {

                $('.rpw-bg-color-picker').wpColorPicker( {

		            defaultColor: '#e5ecee',
					change: _.throttle( function() { $('.rpw-bg-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				$('.rpw-t-color-picker').wpColorPicker( {

		            defaultColor: '#57818d',
					change: _.throttle( function() { $('.rpw-t-color-picker').trigger( 'change' ) }, 3000 ),

				} );

            } );

        </script>

		<p>Title: <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>
        <p>Optional Headline: <input name="<?php echo esc_attr( $this->get_field_name( 'opt_hdr' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['opt_hdr'] ); ?>" style="width: 100%;" /></p>
        <p>Number of posts to show: <input name="<?php echo esc_attr( $this->get_field_name( 'count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['count'] ); ?>" style="width: 50px;" /></p>
        <p><em>The default post style is "Style A".</em></p>
        <p>Post count for "Style B": <input name="<?php echo esc_attr( $this->get_field_name( 'styleB_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleB_count'] ); ?>" style="width: 50px;" /></p>
        <p>Post count for "Style C": <input name="<?php echo esc_attr( $this->get_field_name( 'styleC_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleC_count'] ); ?>" style="width: 50px;" /></p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['date'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'date' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>">Display post date?</label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['comments'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'comments' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'comments' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'comments' ) ); ?>">Display comments icon?</label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['hits'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'hits' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'hits' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'hits' ) ); ?>">Display visitor hits?</label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['recent'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'recent' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'recent' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'recent' ) ); ?>">Recent Posts</label>
        <br><em>Uncheck for "Random Posts".</em>
		</p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>">Box Color:</label>
		<br />
		<input class="rpw-bg-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'background_color' ) ); ?>" value="<?php echo esc_attr( $instance['background_color'] ); ?>" />
        </p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>">Link Color:</label>
		<br />
		<input class="rpw-t-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'text_color' ) ); ?>" value="<?php echo esc_attr( $instance['text_color'] ); ?>" />
        </p>

        <p>Box Opacity:<br />
        <input name="<?php echo esc_attr( $this->get_field_name( 'range' ) ); ?>" type="range" min="0" max="100" step="10" value="<?php echo esc_attr( $instance['range'] ); ?>" />
        </p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['name'] = ( !empty( $new_instance['name'] ) ) ? strip_tags( $new_instance['name'] ) : 'LATEST POSTS';
		$instance['opt_hdr'] = $new_instance['opt_hdr'];
		$instance['count'] = ( !empty( $new_instance['count'] ) ) ? strip_tags( $new_instance['count'] ) : '5';
		$instance['styleB_count'] = $new_instance['styleB_count'];
		$instance['styleC_count'] = $new_instance['styleC_count'];
		$instance['date'] = $new_instance['date'];
		$instance['recent'] = $new_instance['recent'];
		$instance['comments'] = $new_instance['comments'];
		$instance['hits'] = $new_instance['hits'];
		$instance['text_color'] = $new_instance['text_color'];
		$instance['background_color'] = $new_instance['background_color'];
		$instance['range'] = $new_instance['range'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'name' => 'LATEST POSTS', 'opt_hdr' => 'OPTIONAL HEADLINE', 'count' => 5, 'styleB_count' => 1, 'styleC_count' => 3, 'date' => 'on', 'recent' => 'on', 'comments' => 'on', 'hits' => 'on', 'text_color' => '#57818d', 'background_color' => '#e5ecee', 'range' => '100' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$name = apply_filters( 'widget_title', $instance['name'] );
		$opt_hdr = $instance['opt_hdr'];
		$count = $instance['count'];
		$styleB_count = $instance['styleB_count'];
		$styleC_count = $instance['styleC_count'];
		$date = $instance['date'] ? 'true' : 'false';
		$recent = $instance['recent'] ? 'true' : 'false';
		$comments = $instance['comments'] ? 'true' : 'false';
		$hits = $instance['hits'] ? 'true' : 'false';
		$text_color = $instance['text_color'];
		$background_color = $instance['background_color'];
		$range = $instance['range'];

		/* Combine Widget Listing Settings */

		$w_listing_style = 'a';
		$w_listingOrder = 0;

		if ( $styleB_count + $styleC_count > $count ) {

			$styleB_count = 0;
			$styleC_count = 0;

		}

		/* */

		$rpw_rand = rand( 1, 9999999 ); ?>

        <style type="text/css" scoped>

			<?php echo esc_attr( 'a.rpw-' . $rpw_rand ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.rpw-' . $rpw_rand . ':visited' ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.rpw-' . $rpw_rand ); ?> div.related-post-item-header-a .rpih-inner-a,
			<?php echo esc_attr( 'a.rpw-' . $rpw_rand . ':visited' ); ?> div.related-post-item-header-a .rpih-inner-a,
			<?php echo esc_attr( 'a.rpw-' . $rpw_rand ); ?> div.related-post-item-header-b .rpih-inner-b,
			<?php echo esc_attr( 'a.rpw-' . $rpw_rand . ':visited' ); ?> div.related-post-item-header-b .rpih-inner-b,
			<?php echo esc_attr( 'a.rpw-' . $rpw_rand ); ?>,
			<?php echo esc_attr( 'a.rpw-' . $rpw_rand ); ?> div.widget-listing-c { background: rgba(<?php echo esc_attr( metz_hex2rgb( $background_color ) ) . ',' . esc_attr( $range ) / 100; ?>); color: <?php echo esc_attr( $text_color ); ?>; -webkit-transition: all 0.3s ease-out; transition: all 0.3s ease-out; }
			<?php echo esc_attr( 'a.rpw-' . $rpw_rand . ':hover' ); ?>,
			<?php echo esc_attr( 'a.rpw-' . $rpw_rand . ':hover' ); ?> div.widget-listing-c,
			<?php echo esc_attr( 'a.rpw-' . $rpw_rand . ':hover' ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.rpw-' . $rpw_rand . ':hover' ); ?> div.related-post-item-header-a .rpih-inner-a,
			<?php echo esc_attr( 'a.rpw-' . $rpw_rand . ':hover' ); ?> div.related-post-item-header-b .rpih-inner-b { background: rgba(<?php echo esc_attr( metz_hex2rgb( $text_color ) ) . ', 1'; ?>); color: <?php echo esc_attr( $background_color ); ?>; }

		</style>

        <?php

		if ( !empty( $name ) ) {

			echo wp_kses_post( $before_title ) . esc_attr( $name ) . wp_kses_post( $after_title ) . '<div class="montserrat widget-item-opt-hdr">' . esc_attr( $opt_hdr ) . '</div>';

			/* function */

			if ( $recent == 'true' ) {

				$loop_args = array(

					'showposts' => esc_attr( $count ),
					'ignore_sticky_posts' => 1

				);

			} else {

				$loop_args = array(

					'showposts' => esc_attr( $count ),
					'orderby' => 'rand',
					'ignore_sticky_posts' => 1

				);

			}

			$rPosts = new WP_Query( $loop_args );

			while ( $rPosts->have_posts() ) : $rPosts->the_post();

			//Combine Widget Listing Settings Styles

			$w_listingOrder ++;

			if ( $styleB_count > 0 && ( $w_listingOrder > $count - ( $styleB_count + $styleC_count ) && $w_listingOrder <= $count - $styleC_count ) ) {

				$w_listing_style = 'b';

			}

			if ( $styleC_count > 0 && ( $w_listingOrder > $count - $styleC_count ) ) {

				$w_listing_style = 'c';

			}

			if ( $w_listing_style == 'a' || $w_listing_style == 'b' ) { ?>

                <div class="clearfix widget-listing-a-b box-a-wi">

                	<?php if ( $date == 'true' || ( $comments == 'true' && comments_open() ) || $hits == 'true' ) { ?>

                        <div class="montserrat clearfix widget-date-bar">

                            <?php if ( $date == 'true' ) { ?>

                                <div class="left"><?php echo '<a href="' . esc_url( get_the_permalink() ) . '" class="date-a">' . get_the_date() . '</a>' ?></div>

                            <?php } ?>

                                <div class="right">

                                    <?php if ( $comments == 'true' && comments_open() ) { ?>

                                        <a href="<?php esc_url( the_permalink() ); ?>#comments"><i class="fa fa-comment-o i-spcr-r clock"></i><?php comments_number( '0 ', '1 ', '% ' ); ?></a><?php } ?>

                                        <?php if ( $hits == 'true' ) { ?><i class="fa fa-bolt i-spcr-r <?php if ( $comments == 'true' && comments_open() ) { echo 'i-spcr-l2'; } ?> clock"></i><?php echo metz_getPostViews( get_the_ID() ); } ?>

                                </div>

                        </div>

                    <?php } ?>

                    <a class="<?php echo esc_attr( 'rpw-' . $rpw_rand ); ?>" href="<?php esc_url( the_permalink() ); ?>">
                        <?php if ( has_post_thumbnail() ) { ?><div><?php the_post_thumbnail( 'related-thumbnail' ); ?></div><?php } else if ( $w_listing_style == 'a' ) { ?><div class="rp-a-without-image"></div><?php } ?>
                        <div class="related-post-item-header-<?php echo esc_attr( $w_listing_style ); ?> playfair">
							<div class="rpih-inner-<?php echo esc_attr( $w_listing_style ); ?>">
                            	<div class="rpih-text-<?php echo esc_attr( $w_listing_style ); ?>"><?php the_title(); ?></div>
                            </div>
                        </div>
                    </a>
                </div>

			<?php } else if ( $w_listing_style == 'c' ) { ?>

                <a class="<?php echo esc_attr( 'rpw-' . $rpw_rand ); ?>" href="<?php esc_url( the_permalink() ); ?>">
                    <div class="widget-listing-c clearfix">
						<?php if ( has_post_thumbnail() ) { ?><div><?php echo the_post_thumbnail( 'page-navigation-thumbnail' ); ?></div><?php } ?>
                        <div class="widget-listing-c-info <?php if ( has_post_thumbnail() ) { echo 'widget-listing-c-info-with-t'; } ?>">
                        	<div class="table-cell-middle"><span class="playfair widget-listing-c-title"><?php the_title(); ?></span></div>
                        </div>
                    </div>
                </a>

			<?php } ?>

			<?php endwhile;

			wp_reset_postdata();

			/* */

		}

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

/* metz_customSearchWidget Class */
class metz_customSearchWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'metz_customSearchWidget',
			'Metz Widget: Search',
			array( 'description' => "You can search for anything on your site. Can you believe it? :)" )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'text_color' => '#FFF', 'background_color' => '#999', 'border_color' => '#999' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <script type='text/javascript'>

            jQuery( document ).ready( function($) {

                $('.sew-bg-color-picker').wpColorPicker( {

		            defaultColor: '#999',
					change: _.throttle( function() { $('.sew-bg-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				$('.sew-t-color-picker').wpColorPicker( {

		            defaultColor: '#FFF',
					change: _.throttle( function() { $('.sew-t-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				 $('.sew-bo-color-picker').wpColorPicker( {

		            defaultColor: '#999',
					change: _.throttle( function() { $('.sew-bo-color-picker').trigger( 'change' ) }, 3000 ),

				} );

            } );

        </script>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>">Background Color:</label>
		<br />
		<input class="sew-bg-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'background_color' ) ); ?>" value="<?php echo esc_attr( $instance['background_color'] ); ?>" />
        </p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>">Text Color:</label>
		<br />
		<input class="sew-t-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'text_color' ) ); ?>" value="<?php echo esc_attr( $instance['text_color'] ); ?>" />
        </p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'border_color' ) ); ?>">Border Color:</label>
		<br />
		<input class="sew-bo-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'border_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'border_color' ) ); ?>" value="<?php echo esc_attr( $instance['border_color'] ); ?>" />
        </p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['text_color'] = $new_instance['text_color'];
		$instance['background_color'] = $new_instance['background_color'];
		$instance['border_color'] = $new_instance['border_color'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		if ( $id == 'brnhmbx_footer_widgets' ) {

			$fw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColFooter', 1 ) ) { $fw_col_number = '-col2'; }
			echo '<div class="widget-item-footer-outer' . esc_attr( $fw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_home_widgets' ) {

			$hw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColHome', 0 ) ) { $hw_col_number = '-col2'; }
			if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) { $hw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-home-outer' . esc_attr( $hw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_upper_widgets' ) {

			$uw_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_use3ColUpper', 0 ) ) { $uw_col_number = '-col2'; }
			if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) { $uw_col_number = '-col2-sidebar'; }
			echo '<div class="widget-item-upper-outer' . esc_attr( $uw_col_number ) . '">';

		} else if ( $id == 'brnhmbx_header_widgets' ) {

			$hew_col_number = '';
			if ( !get_theme_mod( 'brnhmbx_headerWidgetsCol', 0 ) ) { $hew_col_number = '-col2'; }
			echo '<div class="widget-item-header-outer' . esc_attr( $hew_col_number ) . '">';

		} else {

			echo '<div id="' . esc_attr( $this->id ) . '" class="widget-item clearfix">'; //Widget starts to print information

		}

		$defaults = array( 'text_color' => '#FFF', 'background_color' => '#999', 'border_color' => '#999' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$text_color = $instance['text_color'];
		$background_color = $instance['background_color'];
		$border_color = $instance['border_color'];

		$brnhmbx_tra_TypeKeyword = esc_html__( 'Type keyword to search', 'metz' );

		if ( get_theme_mod( 'metz_ignorePot', 1 ) ) {

		$brnhmbx_tra_TypeKeyword = get_theme_mod( 'brnhmbx_tra_TypeKeyword', 'Type keyword to search' );

		}

		/* function */ ?>

        <div class="clearfix search-widget" style="background-color: <?php echo esc_attr( $background_color ); ?>; border-color: <?php echo esc_attr( $border_color ); ?>;">
            <div class="search-widget-input-box">
                <form role="search" method="get" id="searchform_custom" action="<?php echo home_url( '/' ); ?>">
                    <input class="playfair fs16 search-widget-input" type="text" value="<?php echo esc_attr( $brnhmbx_tra_TypeKeyword ); ?>" name="s" id="s_custom" style="background-color: <?php echo esc_attr( $background_color ); ?>; color: <?php echo esc_attr( $text_color ); ?>;" />
                </form>
            </div>
            <div class="fs16 search-widget-s-icon">
            	<div class="table-cell-middle pr15" style="color: <?php echo esc_attr( $text_color ); ?>;"><i class="fa fa-search"></i></div>
            </div>
        </div>

        <?php

		/* */

		echo '</div>'; //Widget ends printing information

	}

}

/* metz_customSelectedPostsWidget Class */
class metz_customSelectedPostsWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'metz_customSelectedPostsWidget',
			'Metz Widget: Selected Posts',
			array( 'description' => "Display the posts you've selected. Very useful for the posts you want to put forward." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'SELECTED POSTS', 'opt_hdr' => 'OPTIONAL HEADLINE', 'count' => 5, 'styleB_count' => 1, 'styleC_count' => 3, 'date' => 'on', 'comments' => 'on', 'hits' => 'on', 'text_color' => '#756c4c', 'background_color' => '#ebe4ca', 'range' => '100', 'post_1' => '0', 'post_2' => '0', 'post_3' => '0', 'post_4' => '0', 'post_5' => '0' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <script type='text/javascript'>

            jQuery( document ).ready( function($) {

                $('.spw-bg-color-picker').wpColorPicker( {

		            defaultColor: '#ebe4ca',
					change: _.throttle( function() { $('.spw-bg-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				$('.spw-t-color-picker').wpColorPicker( {

		            defaultColor: '#756c4c',
					change: _.throttle( function() { $('.spw-t-color-picker').trigger( 'change' ) }, 3000 ),

				} );

            } );

        </script>

        <p>Post 1 ID: <input id="get-dropdown-val-1" name="<?php echo esc_attr( $this->get_field_name( 'post_1' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['post_1'] ); ?>" style="width: 50px;" /></p>
        <p>Post 2 ID: <input id="get-dropdown-val-2" name="<?php echo esc_attr( $this->get_field_name( 'post_2' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['post_2'] ); ?>" style="width: 50px;" /></p>
        <p>Post 3 ID: <input id="get-dropdown-val-3" name="<?php echo esc_attr( $this->get_field_name( 'post_3' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['post_3'] ); ?>" style="width: 50px;" /></p>
        <p>Post 4 ID: <input id="get-dropdown-val-4" name="<?php echo esc_attr( $this->get_field_name( 'post_4' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['post_4'] ); ?>" style="width: 50px;" /></p>
        <p>Post 5 ID: <input id="get-dropdown-val-5" name="<?php echo esc_attr( $this->get_field_name( 'post_5' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['post_5'] ); ?>" style="width: 50px;" /></p>
		<p>Title: <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>
        <p>Optional Headline: <input name="<?php echo esc_attr( $this->get_field_name( 'opt_hdr' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['opt_hdr'] ); ?>" style="width: 100%;" /></p>
        <p><input name="<?php echo esc_attr( $this->get_field_name( 'count' ) ); ?>" type="hidden" value="<?php echo esc_attr( $instance['count'] ); ?>" /></p>
        <p><em>The default post style is "Style A".</em></p>
        <p>Post count for "Style B": <input name="<?php echo esc_attr( $this->get_field_name( 'styleB_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleB_count'] ); ?>" style="width: 50px;" /></p>
        <p>Post count for "Style C": <input name="<?php echo esc_attr( $this->get_field_name( 'styleC_count' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['styleC_count'] ); ?>" style="width: 50px;" /></p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['date'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'date' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'date' ) ); ?>">Display post date?</label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['comments'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'comments' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'comments' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'comments' ) ); ?>">Display comments icon?</label>
		</p>

        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['hits'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'hits' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'hits' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'hits' ) ); ?>">Display visitor hits?</label>
		</p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>">Box Color:</label>
		<br />
		<input class="spw-bg-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'background_color' ) ); ?>" value="<?php echo esc_attr( $instance['background_color'] ); ?>" />
        </p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>">Link Color:</label>
		<br />
		<input class="spw-t-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'text_color' ) ); ?>" value="<?php echo esc_attr( $instance['text_color'] ); ?>" />
        </p>

        <p>Box Opacity:<br />
        <input name="<?php echo esc_attr( $this->get_field_name( 'range' ) ); ?>" type="range" min="0" max="100" step="10" value="<?php echo esc_attr( $instance['range'] ); ?>" />
        </p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['name'] = ( !empty( $new_instance['name'] ) ) ? strip_tags( $new_instance['name'] ) : 'SELECTED POSTS';
		$instance['opt_hdr'] = $new_instance['opt_hdr'];
		$instance['count'] = ( !empty( $new_instance['count'] ) ) ? strip_tags( $new_instance['count'] ) : '5';
		$instance['styleB_count'] = $new_instance['styleB_count'];
		$instance['styleC_count'] = $new_instance['styleC_count'];
		$instance['date'] = $new_instance['date'];
		$instance['comments'] = $new_instance['comments'];
		$instance['hits'] = $new_instance['hits'];
		$instance['text_color'] = $new_instance['text_color'];
		$instance['background_color'] = $new_instance['background_color'];
		$instance['range'] = $new_instance['range'];
		$instance['post_1'] = $new_instance['post_1'];
		$instance['post_2'] = $new_instance['post_2'];
		$instance['post_3'] = $new_instance['post_3'];
		$instance['post_4'] = $new_instance['post_4'];
		$instance['post_5'] = $new_instance['post_5'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'name' => 'SELECTED POSTS', 'opt_hdr' => 'OPTIONAL HEADLINE', 'count' => 5, 'styleB_count' => 1, 'styleC_count' => 3, 'date' => 'on', 'comments' => 'on', 'hits' => 'on', 'text_color' => '#756c4c', 'background_color' => '#ebe4ca', 'range' => '100', 'post_1' => '0', 'post_2' => '0', 'post_3' => '0', 'post_4' => '0', 'post_5' => '0' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$name = apply_filters( 'widget_title', $instance['name'] );
		$opt_hdr = $instance['opt_hdr'];
		$count = $instance['count'];
		$styleB_count = $instance['styleB_count'];
		$styleC_count = $instance['styleC_count'];
		$date = $instance['date'] ? 'true' : 'false';
		$comments = $instance['comments'] ? 'true' : 'false';
		$hits = $instance['hits'] ? 'true' : 'false';
		$text_color = $instance['text_color'];
		$background_color = $instance['background_color'];
		$range = $instance['range'];
		$post_1 = $instance['post_1'];
		$post_2 = $instance['post_2'];
		$post_3 = $instance['post_3'];
		$post_4 = $instance['post_4'];
		$post_5 = $instance['post_5'];

		/* Combine Widget Listing Settings */

		$w_listing_style = 'a';
		$w_listingOrder = 0;
		$w_selectedCount = 0;

		if ( $post_1 != 0 && $post_1 != 999999 ) { $w_selectedCount++; }
		if ( $post_2 != 0 && $post_2 != 999999 ) { $w_selectedCount++; }
		if ( $post_3 != 0 && $post_3 != 999999 ) { $w_selectedCount++; }
		if ( $post_4 != 0 && $post_4 != 999999 ) { $w_selectedCount++; }
		if ( $post_5 != 0 && $post_5 != 999999 ) { $w_selectedCount++; }

		if ( $styleB_count + $styleC_count > $w_selectedCount ) {

			$styleB_count = 0;
			$styleC_count = 0;

		}

		/* */

		$spw_rand = rand( 1, 9999999 ); ?>

        <style type="text/css" scoped>

			<?php echo esc_attr( 'a.spw-' . $spw_rand ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.spw-' . $spw_rand . ':visited' ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.spw-' . $spw_rand ); ?> div.related-post-item-header-a .rpih-inner-a,
			<?php echo esc_attr( 'a.spw-' . $spw_rand . ':visited' ); ?> div.related-post-item-header-a .rpih-inner-a,
			<?php echo esc_attr( 'a.spw-' . $spw_rand ); ?> div.related-post-item-header-b .rpih-inner-b,
			<?php echo esc_attr( 'a.spw-' . $spw_rand . ':visited' ); ?> div.related-post-item-header-b .rpih-inner-b,
			<?php echo esc_attr( 'a.spw-' . $spw_rand ); ?>,
			<?php echo esc_attr( 'a.spw-' . $spw_rand ); ?> div.widget-listing-c { background: rgba(<?php echo esc_attr( metz_hex2rgb( $background_color ) ) . ',' . esc_attr( $range ) / 100; ?>); color: <?php echo esc_attr( $text_color ); ?>; -webkit-transition: all 0.3s ease-out; transition: all 0.3s ease-out; }
			<?php echo esc_attr( 'a.spw-' . $spw_rand . ':hover' ); ?>,
			<?php echo esc_attr( 'a.spw-' . $spw_rand . ':hover' ); ?> div.widget-listing-c,
			<?php echo esc_attr( 'a.spw-' . $spw_rand . ':hover' ); ?> div.rp-a-without-image,
			<?php echo esc_attr( 'a.spw-' . $spw_rand . ':hover' ); ?> div.related-post-item-header-a .rpih-inner-a,
			<?php echo esc_attr( 'a.spw-' . $spw_rand . ':hover' ); ?> div.related-post-item-header-b .rpih-inner-b { background: rgba(<?php echo esc_attr( metz_hex2rgb( $text_color ) ) . ', 1'; ?>); color: <?php echo esc_attr( $background_color ); ?>; }

		</style>

        <?php

		if ( !empty( $name ) ) {

			echo wp_kses_post( $before_title ) . esc_attr( $name ) . wp_kses_post( $after_title ) . '<div class="montserrat widget-item-opt-hdr">' . esc_attr( $opt_hdr ) . '</div>';

			/* function */

			$loop_args = array(

				'showposts' => esc_attr( $count ),
				'post_type' => 'post',
				'post__in' => array( esc_attr( $post_1 ), esc_attr( $post_2 ), esc_attr( $post_3 ), esc_attr( $post_4 ), esc_attr( $post_5 ) ),
				'ignore_sticky_posts' => 1,
				'orderby' => 'post__in'

			);

			$rPosts = new WP_Query( $loop_args );

			while ( $rPosts->have_posts() ) : $rPosts->the_post();

			//Combine Widget Listing Settings Styles

			$w_listingOrder ++;

			if ( $styleB_count > 0 && ( $w_listingOrder > $w_selectedCount - ( $styleB_count + $styleC_count ) && $w_listingOrder <= $w_selectedCount - $styleC_count ) ) {

				$w_listing_style = 'b';

			}

			if ( $styleC_count > 0 && ( $w_listingOrder > $w_selectedCount - $styleC_count ) ) {

				$w_listing_style = 'c';

			}

			if ( $w_listing_style == 'a' || $w_listing_style == 'b' ) { ?>

                <div class="clearfix widget-listing-a-b box-a-wi">

                	<?php if ( $date == 'true' || ( $comments == 'true' && comments_open() ) || $hits == 'true' ) { ?>

                        <div class="montserrat clearfix widget-date-bar">

                            <?php if ( $date == 'true' ) { ?>

                                <div class="left"><?php echo '<a href="' . esc_url( get_the_permalink() ) . '" class="date-a">' . get_the_date() . '</a>' ?></div>

                            <?php } ?>

                                <div class="right">

                                    <?php if ( $comments == 'true' && comments_open() ) { ?>

                                        <a href="<?php esc_url( the_permalink() ); ?>#comments"><i class="fa fa-comment-o i-spcr-r clock"></i><?php comments_number( '0 ', '1 ', '% ' ); ?></a><?php } ?>

                                        <?php if ( $hits == 'true' ) { ?><i class="fa fa-bolt i-spcr-r <?php if ( $comments == 'true' && comments_open() ) { echo 'i-spcr-l2'; } ?> clock"></i><?php echo metz_getPostViews( get_the_ID() ); } ?>

                                </div>

                        </div>

                    <?php } ?>

                    <a class="<?php echo esc_attr( 'spw-' . $spw_rand ); ?>" href="<?php esc_url( the_permalink() ); ?>">
                        <?php if ( has_post_thumbnail() ) { ?><div><?php the_post_thumbnail( 'related-thumbnail' ); ?></div><?php } else if ( $w_listing_style == 'a' ) { ?><div class="rp-a-without-image"></div><?php } ?>
                        <div class="related-post-item-header-<?php echo esc_attr( $w_listing_style ); ?> playfair">
							<div class="rpih-inner-<?php echo esc_attr( $w_listing_style ); ?>">
                            	<div class="rpih-text-<?php echo esc_attr( $w_listing_style ); ?>"><?php the_title(); ?></div>
                            </div>
                        </div>
                    </a>
                </div>

			<?php } else if ( $w_listing_style == 'c' ) { ?>

                <a class="<?php echo esc_attr( 'spw-' . $spw_rand ); ?>" href="<?php esc_url( the_permalink() ); ?>">
                	<div class="widget-listing-c clearfix">
						<?php if ( has_post_thumbnail() ) { ?><div><?php echo the_post_thumbnail( 'page-navigation-thumbnail' ); ?></div><?php } ?>
                        <div class="widget-listing-c-info <?php if ( has_post_thumbnail() ) { echo 'widget-listing-c-info-with-t'; } ?>">
                        	<div class="table-cell-middle"><span class="playfair widget-listing-c-title"><?php the_title(); ?></span></div>
                        </div>
	                </div>
                </a>

			<?php } ?>

			<?php endwhile;

			wp_reset_postdata();

			/* */

		}

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

/* metz_customSocialWidget Class */
class metz_customSocialWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'metz_customSocialWidget',
			'Metz Widget: Social',
			array( 'description' => "Place your social account icons in a sleek list." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'name' => 'SOCIAL NETWORK', 'opt_hdr' => 'OPTIONAL HEADLINE', 'text_color' => '#FFF', 'background_color' => '#999', 'border_color' => '#999', 'facebook' => 'http://', 'twitter' => 'http://', 'instagram' => 'http://', 'pinterest' => 'http://', 'google' => 'http://', 'tumblr' => 'http://', 'flickr' => 'http://', 'digg' => 'http://', 'linkedin' => 'http://', 'vimeo' => 'http://', 'youtube' => 'http://', 'behance' => 'http://', 'dribble' => 'http://', 'deviantart' => 'http://', 'github' => 'http://', 'bloglovin' => 'http://', 'lastfm' => 'http://', 'soundcloud' => 'http://', 'vk' => 'http://' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <script type='text/javascript'>

            jQuery( document ).ready( function($) {

                $('.sw-bg-color-picker').wpColorPicker( {

		            defaultColor: '#999',
					change: _.throttle( function() { $('.sw-bg-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				$('.sw-t-color-picker').wpColorPicker( {

		            defaultColor: '#FFF',
					change: _.throttle( function() { $('.sw-t-color-picker').trigger( 'change' ) }, 3000 ),

				} );

				 $('.sw-bo-color-picker').wpColorPicker( {

		            defaultColor: '#999',
					change: _.throttle( function() { $('.sw-bo-color-picker').trigger( 'change' ) }, 3000 ),

				} );

            } );

        </script>

		<p>Title: <input name="<?php echo esc_attr( $this->get_field_name( 'name' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['name'] ); ?>" style="width: 100%;" /></p>
        <p>Optional Headline: <input name="<?php echo esc_attr( $this->get_field_name( 'opt_hdr' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['opt_hdr'] ); ?>" style="width: 100%;" /></p>
        <p><em>Write the entire URL addresses. Leave blank if not preferred.</em></p>
        <p>Facebook: <input name="<?php echo esc_attr( $this->get_field_name( 'facebook' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['facebook'] ); ?>" style="width: 100%;" />
        <p>Twitter: <input name="<?php echo esc_attr( $this->get_field_name( 'twitter' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['twitter'] ); ?>" style="width: 100%;" />
        <p>Instagram: <input name="<?php echo esc_attr( $this->get_field_name( 'instagram' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['instagram'] ); ?>" style="width: 100%;" />
        <p>Pinterest: <input name="<?php echo esc_attr( $this->get_field_name( 'pinterest' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['pinterest'] ); ?>" style="width: 100%;" />
        <p>Google+: <input name="<?php echo esc_attr( $this->get_field_name( 'google' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['google'] ); ?>" style="width: 100%;" />
        <p>Tumblr: <input name="<?php echo esc_attr( $this->get_field_name( 'tumblr' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['tumblr'] ); ?>" style="width: 100%;" />
        <p>Flickr: <input name="<?php echo esc_attr( $this->get_field_name( 'flickr' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['flickr'] ); ?>" style="width: 100%;" />
        <p>Digg: <input name="<?php echo esc_attr( $this->get_field_name( 'digg' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['digg'] ); ?>" style="width: 100%;" />
        <p>LinkedIn: <input name="<?php echo esc_attr( $this->get_field_name( 'linkedin' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['linkedin'] ); ?>" style="width: 100%;" />
        <p>Vimeo: <input name="<?php echo esc_attr( $this->get_field_name( 'vimeo' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['vimeo'] ); ?>" style="width: 100%;" />
        <p>YouTube: <input name="<?php echo esc_attr( $this->get_field_name( 'youtube' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['youtube'] ); ?>" style="width: 100%;" />
        <p>Behance: <input name="<?php echo esc_attr( $this->get_field_name( 'behance' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['behance'] ); ?>" style="width: 100%;" />
        <p>Dribbble: <input name="<?php echo esc_attr( $this->get_field_name( 'dribble' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['dribble'] ); ?>" style="width: 100%;" />
        <p>DeviantArt: <input name="<?php echo esc_attr( $this->get_field_name( 'deviantart' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['deviantart'] ); ?>" style="width: 100%;" />
        <p>Github: <input name="<?php echo esc_attr( $this->get_field_name( 'github' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['github'] ); ?>" style="width: 100%;" />
        <p>Bloglovin: <input name="<?php echo esc_attr( $this->get_field_name( 'bloglovin' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['bloglovin'] ); ?>" style="width: 100%;" />
        <p>Lastfm: <input name="<?php echo esc_attr( $this->get_field_name( 'lastfm' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['lastfm'] ); ?>" style="width: 100%;" />
        <p>SoundCloud: <input name="<?php echo esc_attr( $this->get_field_name( 'soundcloud' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['soundcloud'] ); ?>" style="width: 100%;" />
        <p>VK: <input name="<?php echo esc_attr( $this->get_field_name( 'vk' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['vk'] ); ?>" style="width: 100%;" />

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>">Button Background Color:</label>
		<br />
		<input class="sw-bg-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'background_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'background_color' ) ); ?>" value="<?php echo esc_attr( $instance['background_color'] ); ?>" />
        </p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>">Button Text Color:</label>
		<br />
		<input class="sw-t-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'text_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'text_color' ) ); ?>" value="<?php echo esc_attr( $instance['text_color'] ); ?>" />
        </p>

        <p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'border_color' ) ); ?>">Button Border Color:</label>
		<br />
		<input class="sw-bo-color-picker" type="text" id="<?php echo esc_attr( $this->get_field_id( 'border_color' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'border_color' ) ); ?>" value="<?php echo esc_attr( $instance['border_color'] ); ?>" />
        </p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['name'] = ( !empty( $new_instance['name'] ) ) ? strip_tags( $new_instance['name'] ) : 'SOCIAL NETWORK';
		$instance['opt_hdr'] = $new_instance['opt_hdr'];
		$instance['facebook'] = ( !empty( $new_instance['facebook'] ) ) ? strip_tags( $new_instance['facebook'] ) : 'http://';
		$instance['twitter'] = ( !empty( $new_instance['twitter'] ) ) ? strip_tags( $new_instance['twitter'] ) : 'http://';
		$instance['instagram'] = ( !empty( $new_instance['instagram'] ) ) ? strip_tags( $new_instance['instagram'] ) : 'http://';
		$instance['pinterest'] = ( !empty( $new_instance['pinterest'] ) ) ? strip_tags( $new_instance['pinterest'] ) : 'http://';
		$instance['google'] = ( !empty( $new_instance['google'] ) ) ? strip_tags( $new_instance['google'] ) : 'http://';
		$instance['tumblr'] = ( !empty( $new_instance['tumblr'] ) ) ? strip_tags( $new_instance['tumblr'] ) : 'http://';
		$instance['flickr'] = ( !empty( $new_instance['flickr'] ) ) ? strip_tags( $new_instance['flickr'] ) : 'http://';
		$instance['digg'] = ( !empty( $new_instance['digg'] ) ) ? strip_tags( $new_instance['digg'] ) : 'http://';
		$instance['linkedin'] = ( !empty( $new_instance['linkedin'] ) ) ? strip_tags( $new_instance['linkedin'] ) : 'http://';
		$instance['vimeo'] = ( !empty( $new_instance['vimeo'] ) ) ? strip_tags( $new_instance['vimeo'] ) : 'http://';
		$instance['youtube'] = ( !empty( $new_instance['youtube'] ) ) ? strip_tags( $new_instance['youtube'] ) : 'http://';
		$instance['behance'] = ( !empty( $new_instance['behance'] ) ) ? strip_tags( $new_instance['behance'] ) : 'http://';
		$instance['dribble'] = ( !empty( $new_instance['dribble'] ) ) ? strip_tags( $new_instance['dribble'] ) : 'http://';
		$instance['deviantart'] = ( !empty( $new_instance['deviantart'] ) ) ? strip_tags( $new_instance['deviantart'] ) : 'http://';
		$instance['github'] = ( !empty( $new_instance['github'] ) ) ? strip_tags( $new_instance['github'] ) : 'http://';
		$instance['bloglovin'] = ( !empty( $new_instance['bloglovin'] ) ) ? strip_tags( $new_instance['bloglovin'] ) : 'http://';
		$instance['lastfm'] = ( !empty( $new_instance['lastfm'] ) ) ? strip_tags( $new_instance['lastfm'] ) : 'http://';
		$instance['soundcloud'] = ( !empty( $new_instance['soundcloud'] ) ) ? strip_tags( $new_instance['soundcloud'] ) : 'http://';
		$instance['vk'] = ( !empty( $new_instance['vk'] ) ) ? strip_tags( $new_instance['vk'] ) : 'http://';
		$instance['text_color'] = $new_instance['text_color'];
		$instance['background_color'] = $new_instance['background_color'];
		$instance['border_color'] = $new_instance['border_color'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'name' => 'SOCIAL NETWORK', 'opt_hdr' => 'OPTIONAL HEADLINE', 'text_color' => '#FFF', 'background_color' => '#999', 'border_color' => '#999', 'facebook' => 'http://', 'twitter' => 'http://', 'instagram' => 'http://', 'pinterest' => 'http://', 'google' => 'http://', 'tumblr' => 'http://', 'flickr' => 'http://', 'digg' => 'http://', 'linkedin' => 'http://', 'vimeo' => 'http://', 'youtube' => 'http://', 'behance' => 'http://', 'dribble' => 'http://', 'deviantart' => 'http://', 'github' => 'http://', 'bloglovin' => 'http://', 'lastfm' => 'http://', 'soundcloud' => 'http://', 'vk' => 'http://' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$name = apply_filters( 'widget_title', $instance['name'] );
		$opt_hdr = $instance['opt_hdr'];
		$facebook = $instance['facebook'];
		$twitter = $instance['twitter'];
		$instagram = $instance['instagram'];
		$pinterest = $instance['pinterest'];
		$google = $instance['google'];
		$tumblr = $instance['tumblr'];
		$flickr = $instance['flickr'];
		$digg = $instance['digg'];
		$linkedin = $instance['linkedin'];
		$vimeo = $instance['vimeo'];
		$youtube = $instance['youtube'];
		$behance = $instance['behance'];
		$dribble = $instance['dribble'];
		$deviantart = $instance['deviantart'];
		$github = $instance['github'];
		$bloglovin = $instance['bloglovin'];
		$lastfm = $instance['lastfm'];
		$soundcloud = $instance['soundcloud'];
		$vk = $instance['vk'];
		$text_color = $instance['text_color'];
		$background_color = $instance['background_color'];
		$border_color = $instance['border_color'];

		$social_accounts = array( $facebook, $twitter, $instagram, $pinterest, $google, $tumblr, $flickr, $digg, $linkedin, $vimeo, $youtube, $behance, $dribble, $deviantart, $github, $bloglovin, $lastfm, $soundcloud, $vk );

		$social_hdrs = array( 'Facebook', 'Twitter', 'Instagram', 'Pinterest', 'Google+', 'Tumblr', 'Flickr', 'Digg', 'Linkedin', 'Vimeo', 'Youtube', 'Behance', 'Dribbble', 'Deviant Art',
		'Github', 'Bloglove', 'Last FM', 'Soundclo.', 'VK' );

		$social_faIcons = array(
			'fa-facebook-square',
			'fa-twitter',
			'fa-instagram',
			'fa-pinterest-square',
			'fa-google-plus-square',
			'fa-tumblr-square',
			'fa-flickr',
			'fa-digg',
			'fa-linkedin',
			'fa-vimeo-square',
			'fa-youtube',
			'fa-behance',
			'fa-dribbble',
			'fa-deviantart',
			'fa-github',
			'fa-heart',
			'fa-lastfm',
			'fa-soundcloud',
			'fa-vk'
		);

		/* */

		$sw_rand = rand( 1, 9999999 );  ?>

		<style type="text/css" scoped>

			<?php echo esc_attr( 'a.sw-' . $sw_rand ); ?>.social-widget-button,
			<?php echo esc_attr( 'a.sw-' . $sw_rand ); ?>.social-widget-button:visited { background-color: <?php echo esc_attr( $background_color ); ?>; border-color: <?php echo esc_attr( $border_color ); ?>; color: <?php echo esc_attr( $text_color ); ?>; -webkit-transition: all 0.3s ease-out; transition: all 0.3s ease-out; }
			<?php echo esc_attr( 'a.sw-' . $sw_rand ); ?>.social-widget-button:hover { background-color: <?php echo esc_attr( $text_color ); ?>; color: <?php echo esc_attr( $background_color ); ?>; }

		</style>

        <?php

		if ( !empty( $name ) ) {

			echo wp_kses_post( $before_title ) . esc_attr( $name ) . wp_kses_post( $after_title ) . '<div class="montserrat widget-item-opt-hdr">' . esc_attr( $opt_hdr ) . '</div>';

			/* function */

			echo '<ul class="social-widget clearfix mt-7">';

			foreach ( $social_accounts as $key => $sa ) {

				if ( $sa != 'http://' && $sa != '' ) {

					echo '<li><a class="' . esc_attr( 'sw-' . $sw_rand ) . ' social-widget-button clearfix" href="' . esc_url( $sa ) . '" target="_blank"><div class="left"><i class="fa ' . esc_attr( $social_faIcons[ $key ] ) . '"></i></div><div class="montserrat right social-widget-button-text">' . esc_html( $social_hdrs[ $key ] ) . '</div></a></li>';

				}

			}

			echo '</ul>';

			/* */

		}

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

/* metz_customWooProductWidget Class */
class metz_customWooProductWidget extends WP_Widget {

	function __construct() {
		parent::__construct(

			'metz_customWooProductWidget',
			'Metz Widget: Woo Product',
			array( 'description' => "Display a single WooCommerce product in a widget area." )

		);
	}

	//Designing the widget, which will be displayed in the admin dashboard widget location.
	public function form( $instance ) {

		$defaults = array( 'rating' => 'on', 'post_1' => '0' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		?>

        <p>Product ID: <input id="get-dropdown-val-1-w" name="<?php echo esc_attr( $this->get_field_name( 'post_1' ) ); ?>" type="text" value="<?php echo esc_attr( $instance['post_1'] ); ?>" style="width: 50px;" /></p>
        <p>
        <input class="checkbox" type="checkbox" <?php esc_attr( checked( $instance['rating'], 'on' ) ); ?> id="<?php echo esc_attr( $this->get_field_id( 'rating' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'rating' ) ); ?>" />
		<label for="<?php echo esc_attr( $this->get_field_id( 'rating' ) ); ?>">Display rating?</label>
		</p>

		<?php

	}

	// Update the new values in database
	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;

		$instance['rating'] = $new_instance['rating'];
		$instance['post_1'] = $new_instance['post_1'];

		return $instance;

	}

	//Display the stored widget information in webpage.
	function widget( $args, $instance ) {

		extract( $args );

		echo wp_kses_post( $before_widget ); //Widget starts to print information

		$defaults = array( 'rating' => 'on', 'post_1' => '0' );
		$instance = wp_parse_args( ( array ) $instance, $defaults );

		$rating = $instance['rating'] ? 'true' : 'false';
		$post_1 = $instance['post_1'];

		$w_selectedCount = 0;

		if ( $post_1 != 0 && $post_1 != 999999 ) { $w_selectedCount++; }

		/* */

		if ( $w_selectedCount && function_exists( 'WC' ) ) {

			/* function */
			$product = wc_get_product( $post_1 );

			?>

            <div class="clearfix woo-p-widget">
            	<div class="woo-p-widget-inner clearfix">
                    <a href="<?php echo esc_url( get_permalink( $product->id ) ); ?>" title="<?php echo esc_attr( $product->get_title() ); ?>">
                        <?php echo wp_kses_post( $product->get_image( $size = 'shop_catalog' ) ); ?>
                        <div class="mt20 playfair woo-p-widget-title"><?php echo esc_html( $product->get_title() ); ?></div>
                    </a>
                </div>

                <?php if ( $rating == 'true' ) { ?><div class="clearfix woo-p-widget-rating"><?php echo wp_kses_post( $product->get_rating_html() ); ?></div><?php } ?>

                <div class="clearfix woo-p-widget-price"><span class="price"><?php echo wp_kses_post( $product->get_price_html() ); ?></span></div>

				<?php

                echo apply_filters( 'woocommerce_loop_add_to_cart_link',
                    sprintf( '<a href="%s" rel="nofollow" data-product_id="%s" data-product_sku="%s" data-quantity="%s" class="button %s product_type_%s">%s</a>',
                        esc_url( $product->add_to_cart_url() ),
                        esc_attr( $product->id ),
                        esc_attr( $product->get_sku() ),
                        esc_attr( isset( $quantity ) ? $quantity : 1 ),
                        $product->is_purchasable() && $product->is_in_stock() ? 'add_to_cart_button' : '',
                        esc_attr( $product->product_type ),
                        esc_html( $product->add_to_cart_text() )
                    ),
                $product );

                ?>
            </div>

			<?php

			/* */

		}

		echo wp_kses_post( $after_widget ); //Widget ends printing information

	}

}

if ( !function_exists( 'metz_widgets_register' ) ) {
	function metz_widgets_register() {

		// Register Widgets
		if ( class_exists( 'metz_customRecentPostsWidget' ) ) { register_widget( 'metz_customRecentPostsWidget' ); }
		if ( class_exists( 'metz_customPopularPostsWidget' ) ) { register_widget( 'metz_customPopularPostsWidget' ); }
		if ( class_exists( 'metz_customSelectedPostsWidget' ) ) { register_widget( 'metz_customSelectedPostsWidget' ); }
		if ( class_exists( 'metz_customCatPostsWidget' ) ) { register_widget( 'metz_customCatPostsWidget' ); }
		if ( class_exists( 'metz_customCatsWidget' ) ) { register_widget( 'metz_customCatsWidget' ); }
		if ( class_exists( 'metz_customRecentCommentsWidget' ) ) { register_widget( 'metz_customRecentCommentsWidget' ); }
		if ( class_exists( 'metz_customEmptySpaceWidget' ) ) { register_widget( 'metz_customEmptySpaceWidget' ); }
		if ( class_exists( 'metz_customImageWidget' ) ) { register_widget( 'metz_customImageWidget' ); }
		if ( class_exists( 'metz_customFacebookFindUsWidget' ) ) { register_widget( 'metz_customFacebookFindUsWidget' ); }
		if ( class_exists( 'metz_customSocialWidget' ) ) { register_widget( 'metz_customSocialWidget' ); }
		if ( class_exists( 'metz_customSearchWidget' ) ) { register_widget( 'metz_customSearchWidget' ); }
		if ( class_exists( 'metz_customPostWidget' ) ) { register_widget( 'metz_customPostWidget' ); }
		if ( class_exists( 'metz_customAdWidget' ) ) { register_widget( 'metz_customAdWidget' ); }
		if ( class_exists( 'metz_customWooProductWidget' ) ) { register_widget( 'metz_customWooProductWidget' ); }

	}
}
add_action( 'widgets_init', 'metz_widgets_register' );

/* Leaderboard Banners */
if ( !function_exists( 'metz_callLeaderboard_1' ) ) {
	function metz_callLeaderboard_1() {

		$banner_output = '<div class="leaderboard-outer';

		if ( get_theme_mod( 'brnhmbx_opt_BannerPos_1', 'above-full-slider' ) == 'above-full-slider' ) { $banner_output .= '-afs'; }

		if ( get_theme_mod( 'brnhmbx_opt_BannerPos_1', 'above-full-slider' ) == 'above-full-slider' || get_theme_mod( 'brnhmbx_opt_BannerPos_1', 'above-full-slider' ) == 'below-cover-slider' ) {

			$banner_output .= ' leaderboard-full';

		} else {

			if ( is_category() || is_author() || is_tag() || is_archive() || is_search() ) {

				if ( get_theme_mod( 'brnhmbx_opt_Layout_Archive', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout_Archive', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout_Archive', '2col_sidebar' ) == '1_2col_sidebar' ) {

					$banner_output .= ' leaderboard-among';

				} else {

					$banner_output .= ' leaderboard-full';

				}

			} else if ( is_page() ) {

				if ( get_theme_mod( 'brnhmbx_sh_SidebarInnerPage', 1 ) ) {

					$banner_output .= ' leaderboard-among';

				} else {

					$banner_output .= ' leaderboard-full';

				}

			} else if ( is_single() ) {

				if ( !is_attachment() ) {

					if ( ( get_post_format() == '' || get_post_format() == 'aside' || get_post_format() == 'link' ) && get_theme_mod( 'brnhmbx_sh_SidebarPost_Standard', 1 ) ) {

						$banner_output .= ' leaderboard-among';

					} else if ( get_post_format() == 'gallery' && get_theme_mod( 'brnhmbx_sh_SidebarPost_Gallery', 1 ) ) {

						$banner_output .= ' leaderboard-among';

					} else if ( get_post_format() == 'video' && get_theme_mod( 'brnhmbx_sh_SidebarPost_Video', 1 ) ) {

						$banner_output .= ' leaderboard-among';

					} else {

						$banner_output .= ' leaderboard-full';

					}

				} else {

					$banner_output .= ' leaderboard-full';

				}

			} else {

				if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) {

					$banner_output .= ' leaderboard-among';

				} else {

					$banner_output .= ' leaderboard-full';

				}

			}

		}

		$banner_output .= ' zig-zag clearfix"><div class="leaderboard-inner';

		if ( get_theme_mod( 'brnhmbx_opt_BannerPos_1', 'above-full-slider' ) == 'above-full-slider' ) { $banner_output .= '-afs'; }

		$banner_output .= '">' . stripslashes( wp_filter_post_kses( addslashes( get_theme_mod( 'brnhmbx_text_Banner_1', '' ) ) ) ) . '</div></div>';

		if ( get_theme_mod( 'brnhmbx_text_Banner_1', '' ) ) {

			if ( get_theme_mod( 'brnhmbx_opt_BannerPos_1', 'above-full-slider' ) == 'above-full-slider' || get_theme_mod( 'brnhmbx_opt_BannerPos_1', 'above-full-slider' ) == 'below-cover-slider' || get_theme_mod( 'brnhmbx_opt_BannerPos_1', 'above-full-slider' ) == 'above-among-slider' || get_theme_mod( 'brnhmbx_opt_BannerPos_1', 'above-full-slider' ) == 'below-among-slider' ) {

				if ( is_home() || is_page() ) { echo wp_kses_post( $banner_output ); }
				if ( is_archive() && get_theme_mod( 'brnhmbx_sh_Banner_1_Archive', 0 ) ) { echo wp_kses_post( $banner_output ); }
				if ( is_single() && get_theme_mod( 'brnhmbx_sh_Banner_1_Post', 0 ) ) { echo wp_kses_post( $banner_output ); }

			} else {

				echo wp_kses_post( $banner_output );

			}

		}

	}
}

if ( !function_exists( 'metz_callLeaderboard_2' ) ) {
	function metz_callLeaderboard_2() {

		$banner_output = '<div class="leaderboard-outer';

		if ( get_theme_mod( 'brnhmbx_opt_BannerPos_2', 'below-among-slider' ) == 'above-full-slider' ) { $banner_output .= '-afs'; }

		if ( get_theme_mod( 'brnhmbx_opt_BannerPos_2', 'below-among-slider' ) == 'above-full-slider' || get_theme_mod( 'brnhmbx_opt_BannerPos_2', 'below-among-slider' ) == 'below-cover-slider' ) {

			$banner_output .= ' leaderboard-full';

		} else {

			if ( is_category() || is_author() || is_tag() || is_archive() || is_search() ) {

				if ( get_theme_mod( 'brnhmbx_opt_Layout_Archive', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout_Archive', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout_Archive', '2col_sidebar' ) == '1_2col_sidebar' ) {

					$banner_output .= ' leaderboard-among';

				} else {

					$banner_output .= ' leaderboard-full';

				}

			} else if ( is_page() ) {

				if ( get_theme_mod( 'brnhmbx_sh_SidebarInnerPage', 1 ) ) {

					$banner_output .= ' leaderboard-among';

				} else {

					$banner_output .= ' leaderboard-full';

				}

			} else if ( is_single() ) {

				if ( !is_attachment() ) {

					if ( ( get_post_format() == '' || get_post_format() == 'aside' || get_post_format() == 'link' ) && get_theme_mod( 'brnhmbx_sh_SidebarPost_Standard', 1 ) ) {

						$banner_output .= ' leaderboard-among';

					} else if ( get_post_format() == 'gallery' && get_theme_mod( 'brnhmbx_sh_SidebarPost_Gallery', 1 ) ) {

						$banner_output .= ' leaderboard-among';

					} else if ( get_post_format() == 'video' && get_theme_mod( 'brnhmbx_sh_SidebarPost_Video', 1 ) ) {

						$banner_output .= ' leaderboard-among';

					} else {

						$banner_output .= ' leaderboard-full';

					}

				} else {

					$banner_output .= ' leaderboard-full';

				}

			} else {

				if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) {

					$banner_output .= ' leaderboard-among';

				} else {

					$banner_output .= ' leaderboard-full';

				}

			}

		}

		$banner_output .= ' zig-zag clearfix"><div class="leaderboard-inner';

		if ( get_theme_mod( 'brnhmbx_opt_BannerPos_2', 'below-among-slider' ) == 'above-full-slider' ) { $banner_output .= '-afs'; }

		$banner_output .= '">' . stripslashes( wp_filter_post_kses( addslashes( get_theme_mod( 'brnhmbx_text_Banner_2', '' ) ) ) ) . '</div></div>';

		if ( get_theme_mod( 'brnhmbx_text_Banner_2', '' ) ) {

			if ( get_theme_mod( 'brnhmbx_opt_BannerPos_2', 'below-among-slider' ) == 'above-full-slider' || get_theme_mod( 'brnhmbx_opt_BannerPos_2', 'below-among-slider' ) == 'below-cover-slider' || get_theme_mod( 'brnhmbx_opt_BannerPos_2', 'below-among-slider' ) == 'above-among-slider' || get_theme_mod( 'brnhmbx_opt_BannerPos_2', 'below-among-slider' ) == 'below-among-slider' ) {

				if ( is_home() || is_page() ) { echo wp_kses_post( $banner_output ); }
				if ( is_archive() && get_theme_mod( 'brnhmbx_sh_Banner_2_Archive', 0 ) ) { echo wp_kses_post( $banner_output ); }
				if ( is_single() && get_theme_mod( 'brnhmbx_sh_Banner_2_Post', 0 ) ) { echo wp_kses_post( $banner_output ); }

			} else {

				echo wp_kses_post( $banner_output );

			}

		}

	}
}

if ( !function_exists( 'metz_callLeaderboard_3' ) ) {
	function metz_callLeaderboard_3() {

		$banner_output = '<div class="leaderboard-outer';

		if ( get_theme_mod( 'brnhmbx_opt_BannerPos_3', 'below-blog-posts' ) == 'above-full-slider' ) { $banner_output .= '-afs'; }

		if ( get_theme_mod( 'brnhmbx_opt_BannerPos_3', 'below-blog-posts' ) == 'above-full-slider' || get_theme_mod( 'brnhmbx_opt_BannerPos_3', 'below-blog-posts' ) == 'below-cover-slider' ) {

			$banner_output .= ' leaderboard-full';

		} else {

			if ( is_category() || is_author() || is_tag() || is_archive() || is_search() ) {

				if ( get_theme_mod( 'brnhmbx_opt_Layout_Archive', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout_Archive', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout_Archive', '2col_sidebar' ) == '1_2col_sidebar' ) {

					$banner_output .= ' leaderboard-among';

				} else {

					$banner_output .= ' leaderboard-full';

				}

			} else if ( is_page() ) {

				if ( get_theme_mod( 'brnhmbx_sh_SidebarInnerPage', 1 ) ) {

					$banner_output .= ' leaderboard-among';

				} else {

					$banner_output .= ' leaderboard-full';

				}

			} else if ( is_single() ) {

				if ( !is_attachment() ) {

					if ( ( get_post_format() == '' || get_post_format() == 'aside' || get_post_format() == 'link' ) && get_theme_mod( 'brnhmbx_sh_SidebarPost_Standard', 1 ) ) {

						$banner_output .= ' leaderboard-among';

					} else if ( get_post_format() == 'gallery' && get_theme_mod( 'brnhmbx_sh_SidebarPost_Gallery', 1 ) ) {

						$banner_output .= ' leaderboard-among';

					} else if ( get_post_format() == 'video' && get_theme_mod( 'brnhmbx_sh_SidebarPost_Video', 1 ) ) {

						$banner_output .= ' leaderboard-among';

					} else {

						$banner_output .= ' leaderboard-full';

					}

				} else {

					$banner_output .= ' leaderboard-full';

				}

			} else {

				if ( get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '2col_sidebar' || get_theme_mod( 'brnhmbx_opt_Layout', '2col_sidebar' ) == '1_2col_sidebar' ) {

					$banner_output .= ' leaderboard-among';

				} else {

					$banner_output .= ' leaderboard-full';

				}

			}

		}

		$banner_output .= ' zig-zag clearfix"><div class="leaderboard-inner';

		if ( get_theme_mod( 'brnhmbx_opt_BannerPos_3', 'below-blog-posts' ) == 'above-full-slider' ) { $banner_output .= '-afs'; }

		$banner_output .= '">' . stripslashes( wp_filter_post_kses( addslashes( get_theme_mod( 'brnhmbx_text_Banner_3', '' ) ) ) ) . '</div></div>';

		if ( get_theme_mod( 'brnhmbx_text_Banner_3', '' ) ) {

			if ( get_theme_mod( 'brnhmbx_opt_BannerPos_3', 'below-blog-posts' ) == 'above-full-slider' || get_theme_mod( 'brnhmbx_opt_BannerPos_3', 'below-blog-posts' ) == 'below-cover-slider' || get_theme_mod( 'brnhmbx_opt_BannerPos_3', 'below-blog-posts' ) == 'above-among-slider' || get_theme_mod( 'brnhmbx_opt_BannerPos_3', 'below-blog-posts' ) == 'below-among-slider' ) {

				if ( is_home() || is_page() ) { echo wp_kses_post( $banner_output ); }
				if ( is_archive() && get_theme_mod( 'brnhmbx_sh_Banner_3_Archive', 0 ) ) { echo wp_kses_post( $banner_output ); }
				if ( is_single() && get_theme_mod( 'brnhmbx_sh_Banner_3_Post', 0 ) ) { echo wp_kses_post( $banner_output ); }

			} else {

				echo wp_kses_post( $banner_output );

			}

		}

	}
}
/* */

?>
