<!DOCTYPE html>
<html <?php if ( get_theme_mod( 'metz_ignorePot', 1 ) && get_theme_mod( 'brnhmbx_tra_Lang' ) ) { echo 'lang="' . esc_attr( get_theme_mod( 'brnhmbx_tra_Lang' ) ) . '"'; } else { language_attributes(); } ?>>
	<head>
    	<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
		<meta charset="<?php bloginfo( 'charset' ); ?>">
        <?php if ( get_theme_mod( 'brnhmbx_upload_Favicon' ) ) { ?><link rel="icon" href="<?php echo esc_url( get_theme_mod( 'brnhmbx_upload_Favicon' ) ); ?>"><?php } ?>
        <link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />
		<?php wp_head(); ?>
	</head>

<body <?php body_class(); ?>>

	<!-- Sticky Header -->
    <?php if ( get_theme_mod( 'brnhmbx_stickyHeader', 1 ) ) { get_template_part( 'sticky-menu' ); } ?>

    <!-- site-container -->
	<div class="site-container">
        <!-- site-container-inner -->
        <div class="clearfix site-container-inner<?php echo metz_applyLayout(); ?>">
        	<!-- top-bar-outer -->
			<div class="top-bar-outer clearfix">

				<?php if ( get_theme_mod( 'brnhmbx_sh_HeaderSocial', 1 ) || get_theme_mod( 'brnhmbx_sh_HeaderMenu', 1 ) ) { ?>

                    <div class="clearfix header-menu-outer">

						<?php if ( get_theme_mod( 'brnhmbx_sh_HeaderSocial', 1 ) ) { ?>

                            <div id="header-social" class="montserrat fs11">
                            	<div class="social-accounts-footer"><?php echo metz_placeSocialIcons(); ?></div>
                            </div>

                        <?php }

						if ( get_theme_mod( 'brnhmbx_sh_HeaderMenu', 1 ) ) {

							$args_header = array(
								'theme_location' => 'header_menu',
								'container_class' => 'footer-nav montserrat fs11',
								'menu_id'         => 'header-menu',
								'depth'		   => '-1',
								'fallback_cb' => false
							);

							wp_nav_menu( $args_header );

                        } ?>

                    </div>

                <?php }

				if ( get_theme_mod( 'brnhmbx_opt_MenuPos', 'logo-top' ) == 'logo-very-top' ) { get_template_part( 'logo' ); } ?>

                <div class="site-top-outer">
                    <div class="site-top-container clearfix">

						<?php if ( get_theme_mod( 'brnhmbx_opt_MenuPos', 'logo-top' ) == 'logo-left' || get_theme_mod( 'brnhmbx_opt_MenuPos', 'logo-top' ) == 'logo-top' ) {

                            get_template_part( 'logo' );
                            get_template_part( 'primary-menu' );

                        } else if ( get_theme_mod( 'brnhmbx_opt_MenuPos', 'logo-top' ) == 'logo-bottom' || get_theme_mod( 'brnhmbx_opt_MenuPos', 'logo-top' ) == 'logo-very-top' ) {

                        	get_template_part( 'primary-menu' ); ?>

                        <?php } ?>

                    </div>
                </div>

        		<?php if ( get_theme_mod( 'brnhmbx_opt_MenuPos', 'logo-top' ) == 'logo-bottom' ) { get_template_part( 'logo' ); } ?>

				<div id="touch-menu"></div>

                <?php

				if ( get_theme_mod( 'brnhmbx_opt_BannerPos_1', 'above-full-slider' ) == 'above-full-slider' ) { if ( function_exists( 'metz_callLeaderboard_1' ) ) { metz_callLeaderboard_1(); } }
				if ( get_theme_mod( 'brnhmbx_opt_BannerPos_2', 'below-among-slider' ) == 'above-full-slider' ) { if ( function_exists( 'metz_callLeaderboard_2' ) ) { metz_callLeaderboard_2(); } }
				if ( get_theme_mod( 'brnhmbx_opt_BannerPos_3', 'below-blog-posts' ) == 'above-full-slider' ) { if ( function_exists( 'metz_callLeaderboard_3' ) ) { metz_callLeaderboard_3(); } }

				?>

			</div><!-- /top-bar-outer -->

             <?php

				/* Header Widgets */
				ob_start( 'metz_compress' );

				if ( is_active_sidebar( 'brnhmbx_header_widgets' ) && ( is_home() || ( is_single() && get_theme_mod( 'brnhmbx_sh_HeaderWidgetsPost', 0 ) ) || ( is_archive() && get_theme_mod( 'brnhmbx_sh_HeaderWidgetsArchive', 0 ) ) || ( is_page() && get_theme_mod( 'brnhmbx_sh_HeaderWidgetsPage', 0 ) ) ) && get_theme_mod( 'brnhmbx_sh_HeaderWidgets', 1 ) ) {

					 if ( get_theme_mod( 'brnhmbx_sh_HeaderWidgetsFront', 1 ) ) {

						 if ( get_query_var( 'paged' ) <= 1 ) { ?>

							<div class="header-widgets-container clearfix">
								<div class="header-widget-area">
									<div class="header-widget-area-inner<?php if ( !get_theme_mod( 'brnhmbx_headerWidgetsCol', 0 ) ) { echo '-col2'; } ?> clearfix"><?php dynamic_sidebar( 'brnhmbx_header_widgets' ); ?></div>
								</div>
							</div>

						<?php }

					} else { ?>

						<div class="header-widgets-container clearfix">
							<div class="header-widget-area">
								<div class="header-widget-area-inner<?php if ( !get_theme_mod( 'brnhmbx_headerWidgetsCol', 0 ) ) { echo '-col2'; } ?> clearfix"><?php dynamic_sidebar( 'brnhmbx_header_widgets' ); ?></div>
							</div>
						</div>

					<?php }

				} ob_end_flush();
				/* /Header Widgets */ ?>

            <?php if ( get_theme_mod( 'brnhmbx_opt_SliderPosition', 'cover' ) == 'full' ) {

				if ( get_theme_mod( 'brnhmbx_bpts', '0' ) ) {

					metz_blogPostsToSlider();

				} else {

					metz_placeSlider();

				}

			} ?>

            <!-- main-container-outer -->
            <div class="clearfix main-container-outer sticky-header">

            	<?php if ( get_theme_mod( 'brnhmbx_opt_SliderPosition', 'cover' ) == 'cover' ) {

					if ( get_theme_mod( 'brnhmbx_bpts', '0' ) ) {

						metz_blogPostsToSlider();

					} else {

						metz_placeSlider();

					}

				} ?>

                <?php

				if ( get_theme_mod( 'brnhmbx_opt_BannerPos_1', 'above-full-slider' ) == 'below-cover-slider' ) { if ( function_exists( 'metz_callLeaderboard_1' ) ) { metz_callLeaderboard_1(); } }
				if ( get_theme_mod( 'brnhmbx_opt_BannerPos_2', 'below-among-slider' ) == 'below-cover-slider' ) { if ( function_exists( 'metz_callLeaderboard_2' ) ) { metz_callLeaderboard_2(); } }
				if ( get_theme_mod( 'brnhmbx_opt_BannerPos_3', 'below-blog-posts' ) == 'below-cover-slider' ) { if ( function_exists( 'metz_callLeaderboard_3' ) ) { metz_callLeaderboard_3(); } }

				?>

                <!-- main-container -->
                <div class="clearfix main-container<?php echo metz_applyLayout(); ?>">
                    <!-- site-content -->
                    <div class="clearfix site-content<?php echo metz_applyLayout(); ?>">

                    	<?php

						if ( get_theme_mod( 'brnhmbx_opt_BannerPos_1', 'above-full-slider' ) == 'above-among-slider' ) { if ( function_exists( 'metz_callLeaderboard_1' ) ) { metz_callLeaderboard_1(); } }
						if ( get_theme_mod( 'brnhmbx_opt_BannerPos_2', 'below-among-slider' ) == 'above-among-slider' ) { if ( function_exists( 'metz_callLeaderboard_2' ) ) { metz_callLeaderboard_2(); } }
						if ( get_theme_mod( 'brnhmbx_opt_BannerPos_3', 'below-blog-posts' ) == 'above-among-slider' ) { if ( function_exists( 'metz_callLeaderboard_3' ) ) { metz_callLeaderboard_3(); } }

						?>

                    	<?php if ( get_theme_mod( 'brnhmbx_opt_SliderPosition', 'cover' ) == 'among' ) {

							if ( get_theme_mod( 'brnhmbx_bpts', '0' ) ) {

								metz_blogPostsToSlider();

							} else {

								metz_placeSlider();

							}

						} ?>

                        <?php

						if ( get_theme_mod( 'brnhmbx_opt_BannerPos_1', 'above-full-slider' ) == 'below-among-slider' ) { if ( function_exists( 'metz_callLeaderboard_1' ) ) { metz_callLeaderboard_1(); } }
						if ( get_theme_mod( 'brnhmbx_opt_BannerPos_2', 'below-among-slider' ) == 'below-among-slider' ) { if ( function_exists( 'metz_callLeaderboard_2' ) ) { metz_callLeaderboard_2(); } }
						if ( get_theme_mod( 'brnhmbx_opt_BannerPos_3', 'below-blog-posts' ) == 'below-among-slider' ) { if ( function_exists( 'metz_callLeaderboard_3' ) ) { metz_callLeaderboard_3(); } }

						?>
