<?php
/**
 * Pagination - Show numbered pagination for catalog pages.
 *
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     3.3.1
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $wp_query;

if ( $wp_query->max_num_pages <= 1 ) {
	return;
}

$brnhmbx_tra_PrevPost = esc_html__( 'PREVIOUS', 'metz' );
$brnhmbx_tra_NextPost = esc_html__( 'NEXT', 'metz' );

if ( get_theme_mod( 'metz_ignorePot', 1 ) ) {

	$brnhmbx_tra_PrevPost = get_theme_mod( 'brnhmbx_tra_PrevPost', 'PREVIOUS' );
	$brnhmbx_tra_NextPost = get_theme_mod( 'brnhmbx_tra_NextPost', 'NEXT' );

}
?>
<nav class="woocommerce-pagination">
	<?php
		$brnhmbx_woo_paginate_links =  paginate_links( apply_filters( 'woocommerce_pagination_args', array(
			'base'         => esc_url_raw( str_replace( 999999999, '%#%', remove_query_arg( 'add-to-cart', get_pagenum_link( 999999999, false ) ) ) ),
			'format'       => '',
			'add_args'     => '',
			'current'      => max( 1, get_query_var( 'paged' ) ),
			'total'        => $wp_query->max_num_pages,
			'prev_text'    => esc_attr( $brnhmbx_tra_PrevPost ),
			'next_text'    => esc_attr( $brnhmbx_tra_NextPost ),
			'before_page_number' => '<span class="page-number-inner">',
			'after_page_number' => '</span>',
			'type'         => 'list',
			'end_size'     => 1,
			'mid_size'     => 1
		) ) );

		echo '<div class="pagenavi clearfix">' . wp_kses_post( $brnhmbx_woo_paginate_links ) . '</div>';
	?>
</nav>
