<?php
/**
 * Single Product Meta
 *
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     3.0.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $product;

?>
<div class="product_meta">

	<?php do_action( 'woocommerce_product_meta_start' ); ?>

	<?php if ( wc_product_sku_enabled() && ( $product->get_sku() || $product->is_type( 'variable' ) ) ) : ?>

	<span class="sku_wrapper"><?php wp_kses_post( _e( '<i class="fa fa-slack i-spcr-r2 tagicon"></i>', 'metz' ) ); ?> <span class="sku" itemprop="sku"><?php $sku = $product->get_sku(); if ( $sku ) { echo esc_html( $sku ); } else { echo esc_html__( 'N/A', 'metz' ); } ?></span></span>

    <div class="mb20"></div>

	<?php endif; ?>

    <?php echo wc_get_product_category_list( $product->get_id(), '', '<span class="posted_in">' . esc_html( _n( '<i class="fa fa-folder-open-o i-spcr-r2 tagicon"></i>', '<i class="fa fa-folder-open-o i-spcr-r2 tagicon"></i>', count( $product->get_category_ids() ), 'metz' ) ) . ' ', '</span>' ); ?>

    <div class="mb20"></div>

    <?php echo wc_get_product_tag_list( $product->get_id(), '', '<span class="tagged_as">' . esc_html( _n( '<i class="fa fa-tag i-spcr-r3 tagicon"></i>', '<i class="fa fa-tag i-spcr-r3 tagicon"></i>', count( $product->get_tag_ids() ), 'metz' ) ) . ' ', '</span>' ); ?>

	<?php do_action( 'woocommerce_product_meta_end' ); ?>

</div>
